/*
xste is copyright Jan Panteltje 2004 and later.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xste.h"

FD_xste *fdui;


static int fontsizes_modified_flag;


void animation_template_form_heading_or_x_y_select_button_cb(FL_OBJECT *ob, long data)
{
int a;

a = fl_get_button(ob);

select_heading_or_x_y(a);

if(a) selected_animation_template -> status |= ANIMATION_TEMPLATE_SHOW_X_Y_DELTA;
else selected_animation_template -> status &= ~ANIMATION_TEMPLATE_SHOW_X_Y_DELTA;

} /* end function animation_template_form_heading_or_x_y_select_button_cb */


void animation_template_form_xpos_slider_cb(FL_OBJECT *ob, long data)
{
double da;
char temp[80];

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

selected_animation_template -> xpos = da;

fl_set_positioner_xvalue(fdui -> animation_template_form_x_y_positioner, da);
fl_redraw_object(fdui -> animation_template_form_x_y_positioner);

sprintf(temp, "%03d,%03d",\
(int)selected_animation_template -> xpos, (int)selected_animation_template -> ypos);
fl_set_object_label(fdui -> animation_template_form_x_y_position_output_field, temp);
fl_redraw_object(fdui -> animation_template_form_x_y_position_output_field);

new_preview_flag = 1;

} /* end function animation_template_form_xpos_slider_cb */


void animation_template_form_dxpos_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

if(da == 0.0) fl_set_object_color(ob, FL_COL1, FL_COL1);
else fl_set_object_color(ob, FL_DARKORANGE, FL_DARKORANGE);

selected_animation_template -> dxpos = da;

new_preview_flag = 1;

} /* end function animation_template_form_dxpos_slider_cb */


void animation_template_form_dxpos_slider_reset_button_cb(FL_OBJECT *ob, long data)
{

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

selected_animation_template -> dxpos = 0.0;

fl_set_slider_value(fdui -> animation_template_form_dxpos_slider, 0.0);
fl_set_object_color(fdui -> animation_template_form_dxpos_slider, FL_COL1, FL_COL1);

fl_redraw_object(fdui -> animation_template_form_dxpos_slider);

new_preview_flag = 1;

} /* end function animation_template_form_dxpos_slider_reset_button_cb */


void animation_template_form_ypos_slider_cb(FL_OBJECT *ob, long data)
{
double da;
char temp[80];

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

selected_animation_template -> ypos = da;

fl_set_positioner_yvalue(fdui -> animation_template_form_x_y_positioner, v_size - da);
fl_redraw_object(fdui -> animation_template_form_x_y_positioner);

sprintf(temp, "%03d,%03d",\
(int)selected_animation_template -> xpos, (int)selected_animation_template -> ypos);
fl_set_object_label(fdui -> animation_template_form_x_y_position_output_field, temp);
fl_redraw_object(fdui -> animation_template_form_x_y_position_output_field);

new_preview_flag = 1;

} /* end function animation_template_form_ypos_slider_cb */


void animation_template_form_dypos_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

if(da == 0.0) fl_set_object_color(ob, FL_COL1, FL_COL1);
else fl_set_object_color(ob, FL_DARKORANGE, FL_DARKORANGE);

selected_animation_template -> dypos = da;

new_preview_flag = 1;

} /* end function animation_template_form_dypos_slider_cb */


void animation_template_form_dypos_slider_reset_button_cb(FL_OBJECT *ob, long data)
{

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

selected_animation_template -> dypos = 0.0;

fl_set_slider_value(fdui -> animation_template_form_dypos_slider, 0.0);
fl_set_object_color(fdui -> animation_template_form_dypos_slider, FL_COL1, FL_COL1);

fl_redraw_object(fdui -> animation_template_form_dypos_slider);

new_preview_flag = 1;

} /* end function  animation_template_form_dypos_slider_reset_button_cb */


void animation_template_form_fontname_button_cb(FL_OBJECT *ob, long data)
{
char *ptr, *ptr2;
char temp[4096];
FILE *fptr;

if(! selected_animation_template)
	{
	fl_show_alert("select a template first", "command cancelled", "", 0);

	return;
	}

/* start  browser */
sprintf(temp, "%s/.xste/fonts", home_dir);

ptr = (char *)fl_show_fselector("SELECT A FONT FILE", temp, "*.ttf", "*.ttf");
if(! ptr) return;
  
/* prevent empty entries */
if(ptr[0] == 0) return;

/* try to open this file for read */
fptr = fopen(ptr, "r");
if(! fptr)
	{
	fl_show_alert("Cannot open file", ptr, "for read", 0);
	return;
	}
fclose(fptr);

/*
extract the fontname from the path-filename
example:
/root/.xste/fonts/arial.ttf

find the last '/' and start from there
*/

ptr2 = strrchr(ptr, '/');
if(! ptr2)
	{
	fl_show_alert("Cannot parse pathfilename", ptr, "no last '/' found", 0);
	
	return;
	}

/* /arial.ttf */
ptr = strsave(ptr2 + 1);
if(! ptr) return;

selected_animation_template -> fontname = strsave(ptr);

if(! selected_animation_template -> fontname)
	{
	fprintf(stderr, "animation_template_form_fontname_button_cb(): could not strsave fontname\n");

	return;		
	}
	
fl_set_object_label(fdui -> animation_template_form_fontname_output_field,  ptr);

new_preview_flag = 1;

} /* end function animation_template_form_fontname_button_cb */


void animation_template_form_character_point_size_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

ptr = (char*)fl_get_input(ob);
if(! ptr) return;

selected_animation_template -> fontsize = atoi(ptr);

new_preview_flag = 1;

} /* end function animation_template_form_character_point_size_input_field_cb */


void animation_template_form_character_style_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

ptr = (char*)fl_get_input(ob);
if(! ptr) return;

selected_animation_template -> iso = atoi(ptr);

new_preview_flag = 1;

} /* end function animation_template_form_character_style_input_field_cb */


void animation_template_form_outline_thickness_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

ptr = (char*)fl_get_input(ob);
if(! ptr) return;

selected_animation_template -> outline = atof(ptr);

new_preview_flag = 1;

} /* end function animation_template_form_outline_thickness_input_field_cb */


void animation_template_form_blur_radius_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

ptr = (char*)fl_get_input(ob);
if(! ptr) return;

selected_animation_template -> blur = atof(ptr);

new_preview_flag = 1;

} /* end function animation_template_form_blur_radius_input_field_cb */


void animation_template_form_x_y_positioner_cb(FL_OBJECT *ob, long data)
{
char temp[80];

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

selected_animation_template -> xpos = fl_get_positioner_xvalue(ob);
selected_animation_template -> ypos = v_size - fl_get_positioner_yvalue(ob);

sprintf(temp, "%03d,%03d",\
(int)selected_animation_template -> xpos, (int)selected_animation_template -> ypos);
fl_set_object_label(fdui -> animation_template_form_x_y_position_output_field, temp);

fl_set_slider_value(fdui -> animation_template_form_xpos_slider, selected_animation_template -> xpos);
fl_set_slider_value(fdui -> animation_template_form_ypos_slider, selected_animation_template -> ypos);

new_preview_flag = 1;

} /* end function animation_template_form_x_y_positioner_cb */


void animation_template_form_espace_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

if(da < 1.0) fl_set_object_color(ob, FL_DARKORANGE, FL_DARKORANGE);
else if(da > 1.0) fl_set_object_color(ob, FL_YELLOW, FL_YELLOW);
else fl_set_object_color(ob, FL_COL1, FL_COL1);

selected_animation_template -> espace = da;

new_preview_flag = 1;

} /* end function animation_template_form_espace_slider_cb */


void animation_template_form_espace_slider_reset_button_cb(FL_OBJECT *ob, long data)
{

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

selected_animation_template -> espace = 1.0;

fl_set_slider_value(fdui -> animation_template_form_espace_slider, 1.0);
fl_set_object_color(fdui -> animation_template_form_espace_slider, FL_COL1, FL_COL1);

new_preview_flag = 1;

} /* end function animation_template_form_espace_slider_reset_button_cb */


void animation_template_form_despace_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

if(da == 0.0) fl_set_object_color(ob, FL_COL1, FL_COL1);
else fl_set_object_color(ob, FL_DARKORANGE, FL_DARKORANGE);

selected_animation_template -> despace = da;

new_preview_flag = 1;

} /* end function animation_template_form_despace_slider_cb */


void animation_template_form_despace_slider_reset_button_cb(FL_OBJECT *ob, long data)
{

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

selected_animation_template -> despace = 0.0;

fl_set_slider_value(fdui -> animation_template_form_despace_slider, 0.0);
fl_set_object_color(fdui -> animation_template_form_despace_slider, FL_COL1, FL_COL1);

new_preview_flag = 1;

} /* end function animation_template_form_despace_slider_reset_button_cb */


void animation_template_form_color_circle_dial_cb(FL_OBJECT *ob, long data)
{
char temp[80];
double dial_value;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

dial_value = fl_get_dial_value(ob);

selected_animation_template -> color = dial_value;

set_template_dial_color(dial_value, selected_animation_template -> saturation);

sprintf(temp, "%.2f", dial_value);
fl_set_object_label(fdui -> animation_template_form_color_degrees_output_field,  temp);

new_preview_flag = 1;

} /* end function animation_template_form_color_circle_dial_cb */


void animation_template_form_dcolor_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

if(da == 0.0) fl_set_object_color(ob, FL_COL1, FL_COL1);
else fl_set_object_color(ob, FL_DARKORANGE, FL_DARKORANGE);

fl_redraw_object(fdui -> animation_template_form_color_circle_dial);

selected_animation_template -> dcolor = da;

new_preview_flag = 1;

} /* end function animation_template_form_dcolor_slider_cb */


void animation_template_form_dcolor_slider_reset_button_cb(FL_OBJECT *ob, long data)
{

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

selected_animation_template -> dcolor = 0.0;

fl_set_slider_value(fdui -> animation_template_form_dcolor_slider, 0.0);
fl_set_object_color(fdui -> animation_template_form_dcolor_slider, FL_COL1, FL_COL1);

fl_redraw_object(fdui -> animation_template_form_dcolor_slider);

new_preview_flag = 1;

} /* end function animation_template_form_dcolor_slider_reset_button_cb */


void animation_template_form_saturation_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

selected_animation_template -> saturation = da;

set_template_dial_color(selected_animation_template -> color, selected_animation_template -> saturation);

new_preview_flag = 1;

} /* end animation_template_form_saturation_slider_cb */
 

void animation_template_form_dsaturation_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

if(da == 0.0) fl_set_object_color(ob, FL_COL1, FL_COL1);
else fl_set_object_color(ob, FL_DARKORANGE, FL_DARKORANGE);

fl_redraw_object(fdui -> animation_template_form_color_circle_dial);

selected_animation_template -> dsaturation = da;

new_preview_flag = 1;

} /* end animation_template_form_saturation_slider_cb */
 

void animation_template_form_dsaturation_slider_reset_button_cb(FL_OBJECT *ob, long data)
{

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

selected_animation_template -> dsaturation = 0.0;

fl_set_slider_value(fdui -> animation_template_form_dsaturation_slider, 0.0);
fl_set_object_color(fdui -> animation_template_form_dsaturation_slider, FL_COL1, FL_COL1);

fl_redraw_object(fdui -> animation_template_form_dsaturation_slider);

new_preview_flag = 1;

} /* end function animation_template_form_dsaturation_slider_reset_button_cb */


void animation_template_form_contrast_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

selected_animation_template -> contrast = da;

new_preview_flag = 1;

} /* end function animation_template_form_contrast_slider_cb */


void animation_template_form_dcontrast_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

if(da == 0.0) fl_set_object_color(ob, FL_COL1, FL_COL1);
else fl_set_object_color(ob, FL_DARKORANGE, FL_DARKORANGE);

selected_animation_template -> dcontrast = da;

new_preview_flag = 1;

} /* end function animation_template_form_dcontrast_slider_cb */


void animation_template_form_dcontrast_slider_reset_button_cb(FL_OBJECT *ob, long data)
{

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

selected_animation_template -> dcontrast = 0.0;

fl_set_slider_value(fdui -> animation_template_form_dcontrast_slider, 0.0);
fl_set_object_color(fdui -> animation_template_form_dcontrast_slider, FL_COL1, FL_COL1);

new_preview_flag = 1;

} /* end function animation_template_form_dcontrast_slider_reset_button_cb */


void animation_template_form_transparency_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

selected_animation_template -> transparency = da;

new_preview_flag = 1;

} /* end function animation_template_form_transparency_slider_cb */


void animation_template_form_dtransparency_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

if(da == 0.0) fl_set_object_color(ob, FL_COL1, FL_COL1);
else fl_set_object_color(ob, FL_DARKORANGE, FL_DARKORANGE);

selected_animation_template -> dtransparency = da;

new_preview_flag = 1;

} /* end function animation_template_form_dtransparency_slider_cb */


void animation_template_form_dtransparency_slider_reset_button_cb(FL_OBJECT *ob, long data)
{

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

selected_animation_template -> dtransparency = 0.0;

fl_set_slider_value(fdui -> animation_template_form_dtransparency_slider, 0.0);
fl_set_object_color(fdui -> animation_template_form_dtransparency_slider, FL_COL1, FL_COL1);

fl_redraw_object(fdui -> animation_template_form_dtransparency_slider);

new_preview_flag = 1;

} /* end function animation_template_form_dtransparency_slider_reset_button_cb */


void animation_template_form_heading_dial_cb(FL_OBJECT *ob, long data)
{
double da, db;
char temp[80];

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_dial_value(ob);

/* flip the dial increment direction */
db = 360.0 - da;

/* flip north south */
if(db > 180.0) db -= 180.0;
else db += 180.0;

sprintf(temp, "%03d", (int) db);
fl_set_object_label(fdui -> animation_template_form_heading_degrees_output_field, temp);

selected_animation_template -> heading = db;

new_preview_flag = 1;

} /* end function animation_template_form_heading_dial_cb */


void animation_template_form_dheading_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

if(da == 0.0) fl_set_object_color(ob, FL_COL1, FL_COL1);
else fl_set_object_color(ob, FL_DARKORANGE, FL_DARKORANGE);

selected_animation_template -> dheading = da;

new_preview_flag = 1;

} /* end function animation_template_form_dheading_slider_cb */


void animation_template_form_dheading_slider_reset_button_cb(FL_OBJECT *ob, long data)
{

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

selected_animation_template -> dheading = 0.0;

fl_set_slider_value(fdui -> animation_template_form_dheading_slider, 0.0);
fl_set_object_color(fdui -> animation_template_form_dheading_slider, FL_COL1, FL_COL1);

fl_redraw_object(fdui -> animation_template_form_dheading_slider);

new_preview_flag = 1;

} /* end function animation_template_form_dheading_slider_reset_button_cb */


void animation_template_form_speed_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

selected_animation_template -> speed = da;

new_preview_flag = 1;

} /* end function animation_template_form_speed_slider_cb */


void animation_template_form_dspeed_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

if(da == 0.0) fl_set_object_color(ob, FL_COL1, FL_COL1);
else fl_set_object_color(ob, FL_DARKORANGE, FL_DARKORANGE);

selected_animation_template -> dspeed = da;

new_preview_flag = 1;

} /* end function animation_template_form_dspeed_slider_cb */


void animation_template_form_dspeed_slider_reset_button_cb(FL_OBJECT *ob, long data)
{

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

selected_animation_template -> dspeed = 0.0;

fl_set_slider_value(fdui -> animation_template_form_dspeed_slider, 0.0);
fl_set_object_color(fdui -> animation_template_form_dspeed_slider, FL_COL1, FL_COL1);

fl_redraw_object(fdui -> animation_template_form_dspeed_slider);

new_preview_flag = 1;

} /* end function animation_template_form_dspeed_slider_reset_button_cb */


void animation_template_form_zpos_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

selected_animation_template -> zpos = da;

new_preview_flag = 1;

} /* end function animation_template_form_zpos_slider_cb */


void animation_template_form_dzpos_slider_cb(FL_OBJECT *ob, long data)
{
double da;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

da = fl_get_slider_value(ob);

if(da == 0.0) fl_set_object_color(ob, FL_COL1, FL_COL1);
else fl_set_object_color(ob, FL_DARKORANGE, FL_DARKORANGE);

selected_animation_template -> dzpos = da;

new_preview_flag = 1;

} /* end function animation_template_form_zpos_slider_cb */


void animation_template_form_dzpos_slider_reset_button_cb(FL_OBJECT *ob, long data)
{

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

selected_animation_template -> dzpos = 0.0;

fl_set_slider_value(fdui -> animation_template_form_dzpos_slider, 0.0);
fl_set_object_color(fdui -> animation_template_form_dzpos_slider, FL_COL1, FL_COL1);

fl_redraw_object(fdui -> animation_template_form_dzpos_slider);

new_preview_flag = 1;

} /* end function animation_template_form_dzpos_slider_reset_button_cb */


void animation_template_form_center_button_cb(FL_OBJECT *ob, long data)
{
int a;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

a = fl_get_button(ob);

if(a) selected_animation_template -> status |= ANIMATION_TEMPLATE_CENTER;
else selected_animation_template -> status &= ~ANIMATION_TEMPLATE_CENTER;

new_preview_flag = 1;

} /* end function animation_template_form_center_button_cb */


void animation_template_form_reformat_button_cb(FL_OBJECT *ob, long data)
{
int a;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

a = fl_get_button(ob);

if(a) selected_animation_template -> status |= ANIMATION_TEMPLATE_REFORMAT;
else selected_animation_template -> status &= ~ANIMATION_TEMPLATE_REFORMAT;

new_preview_flag = 1;

} /* end function animation_template_form_reformat_button_cb */


void animation_template_form_default_button_cb(FL_OBJECT *ob, long data)
{
if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

selected_animation_template -> fontname = strsave("arial.ttf");
if( ! selected_animation_template -> fontname)
	{
	fprintf(stderr, "animation_template_form_default_button_cb(): strsave fontname failed\n");

	return;
	}

selected_animation_template -> fontsize = 24;
selected_animation_template -> iso = 15;
selected_animation_template -> outline = 1.5;
selected_animation_template -> blur = 1.5;

selected_animation_template -> xpos = h_size / 2;
selected_animation_template -> dxpos = 0.0;
selected_animation_template -> ypos = v_size / 4;
selected_animation_template -> dypos = 0.0;
selected_animation_template -> zpos = 0.0;
selected_animation_template -> dzpos = 0.0;
selected_animation_template -> espace = 1.0;
selected_animation_template -> despace = 0.0; 
selected_animation_template -> vespace = 0.0;
selected_animation_template -> color = 0.0;
selected_animation_template -> dcolor = 0.0;
selected_animation_template -> saturation = 70.0;
selected_animation_template -> dsaturation = 0.0;
selected_animation_template -> contrast = 70.0;
selected_animation_template -> dcontrast = 0.0;
selected_animation_template -> transparency = 0.0;
selected_animation_template -> dtransparency = 0.0;
selected_animation_template -> heading = 0.0;
selected_animation_template -> dheading = 0.0;
selected_animation_template -> speed = 0.0;
selected_animation_template -> dspeed = 0.0;
selected_animation_template -> status = 0; 

fill_in_animation_template_form(selected_animation_template);

new_preview_flag = 1;

} /* end function animation_template_form_default_button_cb */


void animation_template_form_vespace_input_field_cb(FL_OBJECT *ob, long data)
{
char *ptr;

if(! selected_animation_template)
	{
	fl_show_alert("select a template name first", "", "", 0);

	return;
	}

ptr = (char*)fl_get_input(ob);
if(! ptr) return;

selected_animation_template -> vespace = atof(ptr);

new_preview_flag = 1;

} /* end function animation_template_form_vespace_input_field_cb */


void animation_template_form_browser_cb(FL_OBJECT *ob, long data)
{
int selected_line;
int mouse_button;
struct animation_template *pa;

if(debug_flag)
	{
	fprintf(stdout, "animation_template_form_browser_cb():\n");
	}

mouse_button = fl_mouse_button();

selected_line = fl_get_browser(ob); 
if(! selected_line) return;

if(mouse_button == FL_LEFT_MOUSE)
	{
	}

pa = animation_template_line_to_form(selected_line);
selected_animation_template = pa;

fill_in_animation_template_form(pa);

selected_animation_template_browser_line = selected_line;

/* maintain visible indication that line is selected with single click  */
fl_select_browser_line(ob, abs(selected_line) );

new_preview_flag = 1;

} /* end function animation_template_form_browser_cb */


void animation_template_form_browser_double_cb(FL_OBJECT *ob, long data)
{
int selected_line;
int mouse_button;
struct animation_template *pa;

if(debug_flag)
	{
	fprintf(stdout, "animation_template_form_browser_double_cb():\n");
	}

mouse_button = fl_mouse_button();

selected_line = fl_get_browser(ob);
if(! selected_line) return;

/* moved to single click, xform does not see double click on middle mouse */

pa = animation_template_line_to_form(selected_line);
selected_animation_template = pa;

fill_in_animation_template_form(pa);

selected_animation_template_browser_line = selected_line;

/* maintain visible indication that line is selected with single click  */
fl_select_browser_line(ob, abs(selected_line) );

new_preview_flag = 1;

} /* end function animation_template_form_browser_double_cb */


void animation_template_form_input_field_cb(FL_OBJECT *ob, long data)
{
} /* end function animation_template_form_input_field_cb */


void animation_template_form_delete_button_cb(FL_OBJECT *ob, long data)
{
int total_lines;
int s_line;
char *name;
char temp[128];

total_lines = fl_get_browser_maxline(fdui -> animation_template_form_browser);
for(s_line = 1; s_line <= total_lines; s_line++)
	{
	if(fl_isselected_browser_line(fdui -> animation_template_form_browser, s_line) )
		{
		name = (char *) line_to_animation_template(s_line);
		if(!name) return;

		if( strcmp(name, "subtitle") == 0)
			{
			fl_show_alert("erasing 'subtitle' template", "not allowed", "", 0);

			return;
			}

		/* last user confirmation */
		sprintf(temp, "Delete all data for %s???", name);
		if(! fl_show_question(temp, 0) ) /* mouse on no */
			{
			return;
			}

		/* delete structure entry */
		if(! delete_animation_template(name) )/* this tests for existence */
			{
			fl_show_alert(\
			"Cannot delete animation_template", name, "command cancelled", 0);
			return;
			}

		/* nothing selected */	
		selected_animation_template = 0;
		clear_animation_template_form();

		break;
		}/* end selected line */
	}/* end for all lines */

show_animation_templates(SHOW_SAME_POSITION);

new_preview_flag = 1;

} /* end function animation_template_form_delete_button_cb */


void animation_template_form_add_button_cb(FL_OBJECT *ob, long data)
{
int a;
int s_line;
char *ptr;

if(debug_flag)
	{
	fprintf(stdout, "animation_template_form_add_button_cb(): arg none\n");
	}

ptr = (char *) fl_get_input(fdui -> animation_template_form_input_field);
if(! ptr) return;

if(! add_animation_template(ptr) ) return;

show_animation_templates(SHOW_SAME_POSITION);

/* mark new entry in browser */
animation_template_to_line(ptr, &s_line);
fl_select_browser_line(fdui -> animation_template_form_browser, s_line);

a = s_line - 7;
if(a < 0) a = 1;
fl_set_browser_topline(fdui -> animation_template_form_browser, a);

/* clear the input field */
fl_set_input(fdui -> animation_template_form_input_field, "");

selected_animation_template_browser_line = s_line;

selected_animation_template = animation_template_line_to_form(s_line);

if(! selected_animation_template) return;

/* set some defaults */
animation_template_form_default_button_cb(0, 0);

fill_in_animation_template_form(selected_animation_template);

new_preview_flag = 1;

} /* end function animation_template_form_add_button_cb */


void animation_template_form_font_size_up_button_cb(FL_OBJECT *ob, long data)
{
} /* end function animation_template_form_font_size_up_button_cb */


void animation_template_form_font_size_down_button_cb(FL_OBJECT *ob, long data)
{
} /* end function animation_template_form_font_size_down_button_cb */


void animation_template_form_cancel_button_cb(FL_OBJECT *ob, long data)
{

load_project_vars();
load_animation_templates();

animation_template_form_shown_flag = 0;

fl_hide_form(fdui -> animation_template_form);

if(fontsizes_modified_flag)
	{
	load_fontsizes();
	fontsizes_modified_flag = 0;
	}

} /* end function animation_template_form_cancel_button_cb */


void animation_template_form_accept_button_cb(FL_OBJECT *ob, long data)
{

if(! selected_animation_template)
	{
//	if(! fl_show_question("Nothing was selected, changes have no effect, OK?", 0) ) return; /* mouse on no */
	}

if( selected_animation_template)
	{
	/* resize in main form may have happened, that sets the new bound, but not xpos and ypos */
	selected_animation_template -> xpos =\
		fl_get_positioner_xvalue(fdui -> animation_template_form_x_y_positioner);
	selected_animation_template -> ypos =\
		v_size - fl_get_positioner_yvalue(fdui -> animation_template_form_x_y_positioner);
	}

save_animation_templates();
save_project_vars();

if(fontsizes_modified_flag)
	{
	save_fontsizes();

	fontsizes_modified_flag = 0;
	}

fl_hide_form(fdui -> animation_template_form);

animation_template_form_shown_flag = 0;
} /* end function animation_template_form_accept_button_cb */


