/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xste.h"

extern FD_xste *fdui;
extern FD_xste *fd_main_form;


int calculate_text_lines(struct frame *pa, int *lines)
{
char *tptr, *cptr;

if(debug_flag)
	{
	printf("calculate_text_lines(): arg pa=%p lines=%p\n", pa, lines);
	}

/* argument check */
if(! pa) return 0;
if(! lines) return 0;

line_h_start = h_factor * (double)h_size;
line_h_end = (double)h_size - (double)line_h_start;

/* reformat text inserting (multiple) '/n' if too long */ 
tptr = p_reformat_text(pa, line_h_end - line_h_start);
if(! tptr)
	{
	printf("calculate_text_lines(): could not reformat text=%s\n", pa -> text);
	
	/* return error */
	return 0;
	} /* end if reformat text failed */		

/* from how many '\n' we can see how many lines */
cptr = tptr;
*lines = 1; /* at least one */
while(1) /* all chars in tptr */
	{
	/* test for end of string tptr */
	if(*cptr == 0) break;
	if(*cptr == '\n') (*lines)++;

	cptr++;
	}	

free(tptr);

/* some limit */
if(*lines > MAX_SCREEN_LINES) *lines = MAX_SCREEN_LINES;

if(debug_flag)
	{
	fprintf(stdout, "calculate_text_lines(): returning *lines=%d\n", *lines);
	}

return 1;
} /* end function calculate_text_lines */

