/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xste.h"

FD_xste *fdui;


int show_ebu_general_subtitle_information_form()
{
char temp[1024];

if(debug_flag)
	{
	fprintf(stdout, "show_ebu_general_subtitle_information_form(): arg none\n");
	}

/* load old settings */
if(! load_ebu_gsi() )
	{
	/* If no previous clear some user inputs for a start */
	fl_set_input(fdui -> ebu_general_subtitle_information_form_original_program_title_input, "");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_original_program_title_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_original_episode_title_input, "");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_original_episode_title_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_translated_program_title_input, "");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_translated_program_title_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_translated_episode_title_input, "");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_translated_episode_title_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_original_translators_name_input, "");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_original_translators_name_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_translators_contact_details_input, "");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_translators_contact_details_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_publisher_input, "");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_publisher_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_editors_name_input, "");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_editors_name_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_editors_contact_details_input, "");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_editors_contact_details_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_subtitle_list_reference_code_input, "");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_subtitle_list_reference_code_input);

	if(! get_current_date(temp) ) return 0;
	fl_set_input(fdui -> ebu_general_subtitle_information_form_creation_date_input, temp);
	fl_set_input(fdui -> ebu_general_subtitle_information_form_revision_date_input, temp);
	/* to variable */
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_creation_date_input);
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_revision_date_input);


	fl_set_input(fdui -> ebu_general_subtitle_information_form_code_page_number_input, "850");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_code_page_number_input);

	fl_set_button(fdui -> ebu_general_subtitle_information_form_display_standard_code_teletext1_button, 1);
	fl_call_object_callback(\
		fdui -> ebu_general_subtitle_information_form_display_standard_code_teletext1_button);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_character_code_input, "15");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_character_code_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_language_code_input, "33");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_language_code_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_max_columns_input, "40");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_max_columns_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_max_rows_input, "23");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_max_rows_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_revision_number_input, "1");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_revision_number_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_timecode_start_of_program_input, "00000000");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_timecode_start_of_program_input);

	fl_set_button(fdui -> ebu_general_subtitle_information_form_timecode_valid_button, 1);
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_timecode_valid_button);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_country_of_origin_input, "NLD");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_country_of_origin_input);

	}


/* this will set data in the form */
if(! xste_frames_to_ebu_gsi_tti() ) return 0;

fl_show_form(fdui -> ebu_general_subtitle_information_form, FL_PLACE_CENTER, FL_TRANSIENT, "");

ebu_general_subtitle_information_form_shown_flag = 1;

return 1;
} /* end function show_ebu_general_subtitle_information_form */


int set_ebu_sti_defaults(char *language)
{
char temp[1024];

if(debug_flag)
	{
	fprintf(stdout, "set_ebu_sti_defaults(): arg language=%s\n", language);
	}

if(strcasecmp(language, "dutch") == 0)
	{
	if(! fl_show_question("This will set all fields to default values\nfor the Dutch language, OK?", 0) ) /* mouse on no */ return 0;

	if(! get_current_date(temp) ) return 0;

	fl_set_input(fdui -> ebu_general_subtitle_information_form_creation_date_input, temp);
	fl_set_input(fdui -> ebu_general_subtitle_information_form_revision_date_input, temp);

	/* to variable */
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_revision_date_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_code_page_number_input, "850");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_code_page_number_input);

	fl_set_button(fdui -> ebu_general_subtitle_information_form_display_standard_code_teletext1_button, 1);
	fl_call_object_callback(\
		fdui -> ebu_general_subtitle_information_form_display_standard_code_teletext1_button);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_character_code_input, "15");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_character_code_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_language_code_input, "33");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_language_code_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_max_columns_input, "40");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_max_columns_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_max_rows_input, "23");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_max_rows_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_revision_number_input, "1");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_revision_number_input);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_timecode_start_of_program_input, "00000000");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_timecode_start_of_program_input);

	fl_set_button(fdui -> ebu_general_subtitle_information_form_timecode_valid_button, 1);
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_timecode_valid_button);

	fl_set_input(fdui -> ebu_general_subtitle_information_form_country_of_origin_input, "NLD");
	fl_call_object_callback(fdui -> ebu_general_subtitle_information_form_country_of_origin_input);

	return 1;
	}


return 0;
} /* end function set_ebu_sti_defaults */


int save_ebu_gsi()
{
char temp[4096];
FILE *fptr;

if(debug_flag)
	{
	fprintf(stdout, "save_ebu_gsi(): arg none\n");
	}

sprintf(temp, "%s/.subtitles/%s/ebu_gsi.dat", home_dir, selected_project);

fptr = fopen(temp, "w");
if(! fptr)
	{
	fl_show_alert("Could not open file", temp, "for write,\nusing defaults", 1);

	return 0;
	}

/* Byte 0-2 Code Page Number CPN */
// 850 multilangual -> 0x38 0x35 0x30 
//char code_page_number[3];
fprintf(fptr, "%s\n", pebu_gsi -> code_page_number);
	
/* Byte 3-10 Disc Format Code DFC */
// STL25.01 for 25 fps  ''S' 'T' 'L' '2' '5' '.' '0' '1'
// STL30.01 for 30 fps
//char disk_format_code[8];
fprintf(fptr, "%s\n", pebu_gsi -> disk_format_code);

/* Byte 11 Display Standard Code */
// Undifined 0x20
// Open Subtitling 0x30
// Level 1 Teletext 0x31
// Level 2 teletext 0x32
//char display_standard_code[1];

if( (pebu_gsi -> display_standard_code[0] >= 0x30) && (pebu_gsi -> display_standard_code[0] < 0x33) )
	{
	fprintf(fptr, "%s\n", pebu_gsi -> display_standard_code);
	}
else /* force valid input */
	{
	fprintf(fptr, "0\n");
	}

/* Byte 12-13 Character Code Table number CCT */
// Latin 0x30 0x30
// Latin /Cyrillic	0x30 0x31
// Latin/Arabic		0x30 x032
// Latin/Greek		0x30 0x33
// Latin/Hebrew		0x30 0x34
//char character_code_table_number[2];
fprintf(fptr, "%s\n", pebu_gsi -> character_code_table_number);

/* Byte 14-15 Language Code LC */
// Dutch = 0x33 should this be 0x00 0x33 or 0x33 0x33 or 0x33 0x00 ??????
// GAMBLE 0x33 0x00 (second byte reserved for national assignment)
//char language_code[2];
fprintf(fptr, "%s\n", pebu_gsi -> language_code);

/* Byte 16-47 Original Program Title OPT */
//char original_program_title[32];
fprintf(fptr, "%s\n", pebu_gsi -> original_program_title);

/* Byte 48-79 Original Episode Title OET */
//char original_episode_title[32];	
fprintf(fptr, "%s\n", pebu_gsi -> original_episode_title);

/* Byte 80-111 Translated Program Title TPT */
//char translated_program_title[32];
fprintf(fptr, "%s\n", pebu_gsi -> translated_program_title);

/* Byte 112-143 Translated Episode Title TET */
//char translated_episode_title[32];
fprintf(fptr, "%s\n", pebu_gsi -> translated_episode_title);

/* Byte 144-175 Tranlators Name TN */
//char translators_name[32];
fprintf(fptr, "%s\n", pebu_gsi -> translators_name);

/* Byte 176-207 Translators Contact Details TCD */
//char translators_contact_details[32];
fprintf(fptr, "%s\n", pebu_gsi -> translators_contact_details);

/* Byte 208-223 Subtitle List Reference code SLR */
// 16 //character string as reference for subtitle list
//char subtitle_list_reference_code[16];
fprintf(fptr, "%s\n", pebu_gsi -> subtitle_list_reference_code);

/* Byte 224-229 Creation Date CD */
// ISO8601 YYMMDD
//char creation_date[6];
fprintf(fptr, "%s\n", pebu_gsi -> creation_date);

/* Byte 230-235 Revision Date RD */
// ISO8601 YYMMDD
//char revision_date[6];
fprintf(fptr, "%s\n", pebu_gsi -> revision_date);

/* Byte 236-237 Revision Number RN */
// 0-99 decimal
//char revision_number[2];
fprintf(fptr, "%s\n", pebu_gsi -> revision_number);

/* Byte 238-242 Total Number of Text and Timing Information (TTI) blocks TNB */
// 0-99999 decimal
//char total_number_of_text_and_timing_information[5];
fprintf(fptr, "%s\n", pebu_gsi -> total_number_of_text_and_timing_information);

/* Byte 243-247 Total Number of Subtitles TNS */
// 0-99999 decimal
//char number_of_subtitles[5];
fprintf(fptr, "%s\n", pebu_gsi -> number_of_subtitles);

/* Byte 248-250 Total  Number of Subtitle Groups TNG */
// 0-255 decimal
//char total_number_of_subtitle_groups[3];
fprintf(fptr, "%s\n", pebu_gsi -> total_number_of_subtitle_groups);

/* Byte 251-252 Maximum Number of Displayable Characters in any text row MNC */
// 0-99 decimal
//char maximum_displayable_characters_in_any_text_row[2];
fprintf(fptr, "%s\n", pebu_gsi -> maximum_displayable_characters_in_any_text_row);

/* Byte 253-254 Maximum Number of Displayable Rows MNR */
// 0-99 decimal
//char maximum_number_of_displayable_rows[2];
fprintf(fptr, "%s\n", pebu_gsi -> maximum_number_of_displayable_rows);

/* Byte 255 Time Code: Status TCS */
// 0x30 Not intended for use (TCP and TCF in GSI block; and TCI TCO in TTI blocks)
// 0x31 Intended for use
//char timecode_status[1];
fprintf(fptr, "%s\n", pebu_gsi -> timecode_status);

/* Byte 256-263 Time Code: Start Of Program TCP */
// hhmmssff
//char timecode_start_of_program[8];
fprintf(fptr, "%s\n", pebu_gsi -> timecode_start_of_program);

/* Byte 264-271 Time Code: First In-Cue TCF*/
// hhmmssff
//char timecode_first_in_cue[8];
fprintf(fptr, "%s\n", pebu_gsi -> timecode_first_in_cue);

/* Byte 272 Total Number of Disks TND */
// <= 9
//char total_number_of_disks[1];
fprintf(fptr, "%s\n", pebu_gsi -> total_number_of_disks);

/* Byte 273 Disk Sequence Number DSN */
// 1-9
//char disk_sequence_number[1];
fprintf(fptr, "%s\n", pebu_gsi -> disk_sequence_number);

/* Byte 274-276 Country of Origin CO */
// NLD
//char country_of_origin[3];
fprintf(fptr, "%s\n", pebu_gsi -> country_of_origin);

/* Byte 277-308 Publisher PUB */
//char publisher[32];
fprintf(fptr, "%s\n", pebu_gsi -> publisher);

/* Byte 309-340 Editors Name EN */
//char editors_name[32];
fprintf(fptr, "%s\n", pebu_gsi -> editors_name);

/* Byte 341-372 Editor's Contact Details ECD */
//char editors_contact_details[32];
fprintf(fptr, "%s\n", pebu_gsi -> editors_contact_details);

/* Byte 373-447 Spare Bytes */
//char spare_bytes[75];
/* SPARE BYTES = EMPTY STRING */
pebu_gsi -> spare_bytes[0] = 0;
//fprintf(fptr, "%s\n", pebu_gsi -> spare_bytes);
fprintf(fptr, "\n");

/* Byte 448-1023 User-Define Area UDA */
//char user_defined_area[576];
/* USER DEFINED AREA IS EMPTY STRING */
pebu_gsi -> user_defined_area[0] = 0;
//fprintf(fptr, "%\n", pebu_gsi -> user_defined_area);
fprintf(fptr, "\n");

fclose(fptr);

return 1;
} /* end function save_ebu_gsi */


int load_ebu_gsi()
{
int a;
char temp[READSIZE];
FILE *fptr;

if(debug_flag)
	{
	fprintf(stdout, "load_ebu_gsi(): arg none\n");
	}

sprintf(temp, "%s/.subtitles/%s/ebu_gsi.dat", home_dir, selected_project);

fptr = fopen(temp, "r");
if(! fptr)
	{
	fl_show_alert(\
		"Could not open file", temp, "for read,\nusing defaults", 1);

	return 0;
	}

while(1)
	{
	/* closes file if EOF */

	/* use temp, else no data after while, compiler bug */
	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> code_page_number, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> disk_format_code, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> display_standard_code, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> character_code_table_number, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> language_code, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> original_program_title, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> original_episode_title, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> translated_program_title, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> translated_episode_title, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> translators_name, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> translators_contact_details, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> subtitle_list_reference_code, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> creation_date, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> revision_date, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> revision_number, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> total_number_of_text_and_timing_information, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> number_of_subtitles, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> total_number_of_subtitle_groups, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> maximum_displayable_characters_in_any_text_row, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> maximum_number_of_displayable_rows, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> timecode_status, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> timecode_start_of_program, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> timecode_first_in_cue, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> total_number_of_disks, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> disk_sequence_number, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> country_of_origin, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> publisher, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> editors_name, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> editors_contact_details, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> spare_bytes, temp);

	a = readline(fptr, temp);
	if(a == EOF) break;
	strcpy(pebu_gsi -> user_defined_area, temp);

	} /* end while read lines from file */

/* set the fields and buttons in the EBU gsi form */	

set_ebu_gsi_form_vars_to_fields();

return 1;
} /* end function load_ebu_gsi */


int set_ebu_gsi_form_vars_to_fields()
{
if(debug_flag)
	{
	fprintf(stdout, "set_ebu_gsi_form_vars_to_fields(): arg none\n");
	}

fl_set_input(fdui -> ebu_general_subtitle_information_form_code_page_number_input,\
	pebu_gsi -> code_page_number);
	
fl_set_input(fdui -> ebu_general_subtitle_information_form_disk_format_code_input,\
	pebu_gsi -> disk_format_code);

if(pebu_gsi -> display_standard_code[0] == 0x30)
	{
	fl_set_button(fdui -> ebu_general_subtitle_information_form_display_standard_code_open_button, 1);
	}
else if(pebu_gsi -> display_standard_code[0] == 0x31)
	{
	fl_set_button(fdui -> ebu_general_subtitle_information_form_display_standard_code_teletext1_button, 1);
	}
else if(pebu_gsi -> display_standard_code[0] == 0x32)
	{
	fl_set_button(fdui -> ebu_general_subtitle_information_form_display_standard_code_teletext2_button, 1);
	}

fl_set_input(fdui -> ebu_general_subtitle_information_form_character_code_input,\
	pebu_gsi -> character_code_table_number);

fl_set_input(fdui -> ebu_general_subtitle_information_form_language_code_input,\
	pebu_gsi -> language_code);

fl_set_input(fdui -> ebu_general_subtitle_information_form_original_program_title_input,\
	pebu_gsi -> original_program_title);

fl_set_input(fdui -> ebu_general_subtitle_information_form_original_episode_title_input,\
	pebu_gsi -> original_episode_title);

fl_set_input(fdui -> ebu_general_subtitle_information_form_translated_program_title_input,\
	pebu_gsi -> translated_program_title);

fl_set_input(fdui -> ebu_general_subtitle_information_form_translated_episode_title_input,\
	pebu_gsi -> translated_episode_title);

fl_set_input(fdui -> ebu_general_subtitle_information_form_original_translators_name_input,\
	pebu_gsi -> translators_name);

fl_set_input(fdui -> ebu_general_subtitle_information_form_translators_contact_details_input,\
	pebu_gsi -> translators_contact_details);

fl_set_input(fdui -> ebu_general_subtitle_information_form_subtitle_list_reference_code_input,\
	pebu_gsi -> subtitle_list_reference_code);

fl_set_input(fdui -> ebu_general_subtitle_information_form_creation_date_input,\
	pebu_gsi -> creation_date);

fl_set_input(fdui -> ebu_general_subtitle_information_form_revision_date_input,\
	pebu_gsi -> revision_date);

fl_set_input(fdui -> ebu_general_subtitle_information_form_revision_number_input,\
	pebu_gsi -> revision_number);

fl_set_input(fdui -> ebu_general_subtitle_information_form_tti_blocks_input,\
	pebu_gsi -> total_number_of_text_and_timing_information);

fl_set_input(fdui -> ebu_general_subtitle_information_form_number_of_subtitles_input,\
	pebu_gsi -> number_of_subtitles);

fl_set_input(fdui -> ebu_general_subtitle_information_form_subtitle_groups_input,\
	pebu_gsi -> total_number_of_subtitle_groups);

fl_set_input(fdui -> ebu_general_subtitle_information_form_max_columns_input,\
	pebu_gsi -> maximum_displayable_characters_in_any_text_row);

fl_set_input(fdui -> ebu_general_subtitle_information_form_max_rows_input,\
	pebu_gsi -> maximum_number_of_displayable_rows);

set_timecode_valid_button();

fl_set_input(fdui -> ebu_general_subtitle_information_form_timecode_start_of_program_input,\
	pebu_gsi -> timecode_start_of_program);

fl_set_input(fdui -> ebu_general_subtitle_information_form_timecode_first_cue_in_input,\
	pebu_gsi -> timecode_first_in_cue);

fl_set_input(fdui -> ebu_general_subtitle_information_form_number_of_disks_input,\
	pebu_gsi -> total_number_of_disks);

fl_set_input(fdui -> ebu_general_subtitle_information_form_disk_sequence_number_input,\
	pebu_gsi -> disk_sequence_number);

fl_set_input(fdui -> ebu_general_subtitle_information_form_country_of_origin_input,\
	pebu_gsi -> country_of_origin);

fl_set_input(fdui -> ebu_general_subtitle_information_form_publisher_input,\
	pebu_gsi -> publisher);

fl_set_input(fdui -> ebu_general_subtitle_information_form_editors_name_input,\
	pebu_gsi -> editors_name);

fl_set_input(fdui -> ebu_general_subtitle_information_form_editors_contact_details_input,\
	pebu_gsi -> editors_contact_details);

return 1;
} /* end function set_ebu_gsi_form_vars_to_fields */


int set_timecode_valid_button()
{
if(debug_flag)
	{
	fprintf(stdout, "set_timecode_valid_button(): arg none\n");
	}

if(pebu_gsi -> timecode_status[0] == 0x30)
	{
	fl_set_button(fdui -> ebu_general_subtitle_information_form_timecode_valid_button, 0);
	fl_set_object_label(fdui -> ebu_general_subtitle_information_form_timecode_valid_button, "TIMECODE OFF");
	}
else
	{
	fl_set_button(fdui -> ebu_general_subtitle_information_form_timecode_valid_button, 1);
	fl_set_object_label(fdui -> ebu_general_subtitle_information_form_timecode_valid_button, "TIMECODE VALID");
	}

return 1;
} /* end function set_timecode_valid_button */


int get_current_date(char *date)
{
struct tm *universal_time, *gmtime();
char *old_locale, *saved_locale;
char *ptr;
time_t now;

if(debug_flag)
	{
	fprintf(stdout, "get_current_date(): arg date=%p\n", date);
	}

/* 
set the locale to english language even if env shows otherwise
*/
/* Get the name of the current locale */
old_locale = setlocale (LC_ALL, NULL);
     
/* Copy the name so it won't be clobbered by `setlocale' */
saved_locale = strdup (old_locale);
if (saved_locale == NULL)
	{
	fprintf(stdout, "get_universal_time_as_string(): Out of memory\n");

	return 0;
	}     

/* 
Now change the locale to US english for 'Wed and not for example 'wo'
server may not be able to parse something like 'wo'.
*/
ptr = setlocale(LC_ALL, "en_US");
if(! ptr)
	{
	fprintf(stdout, "get_universal_time_as_string(); could not setlocale\n");

	return 0;
	}

/* 
decided to adapt to universal time (UT == GMT).
New format:
from rfc1036.html:
Wdy, DD Mon YY HH:MM:SS TIMEZONE 
*/

// ISO8601 YYMMDD
now = time(0);
universal_time = gmtime(&now);
strftime (date, 7, "%y%m%d", universal_time);

//ptr = strsave(temp);

if(debug_flag)
	{
	fprintf(stdout, "get_universal_time_as_string(): date=%s\n", date);
	}

/* Restore the original locale */
setlocale (LC_ALL, saved_locale);
free (saved_locale);

return 1;
} /* end function get_current_date */

