/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "xste.h"

extern FD_xste *fdui;
extern FD_xste *fd_export_form;


int export_form_modified_flag;
static int fontsizes_modified_flag;
static int filename_error_flag;


void export_form_use_animation_templates_button_cb(FL_OBJECT *ob, long data)
{
use_animation_templates_flag = fl_get_button(ob);

export_form_modified_flag = 1;
} /* end function export_form_use_animation_templates_button_cb */


void export_form_enable_chapter_list_output_button_cb(FL_OBJECT *ob, long data)
{
enable_chapter_list_output_flag = fl_get_button(ob);

export_form_modified_flag = 1;
} /* end function export_form_enable_chapter_list_output_button_cb */



void export_form_ppml_use_dvd_colors_button_cb(FL_OBJECT *ob, long data)
{
ppml_use_dvd_colors_flag = fl_get_button(ob);

export_form_modified_flag = 1;
} /* end function export_form_ppml_use_dvd_colors_button_cb */


void export_form_ppml_enable_monitor_button_cb(FL_OBJECT *ob, long data)
{
ppml_enable_monitor_flag = fl_get_button(ob);

export_form_modified_flag = 1;
} /* export_form_ppml_enable_monitor_button_cb */


void export_form_ebu_general_subtitle_information_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "export_form_ebu_general_subtitle_information_button_cb(): arg none\n");
	}

show_ebu_general_subtitle_information_form();

} /* end function export_form_ebu_general_subtitle_information_button_cb */


void export_form_enable_ppml_output_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "export_form_enable_ppml_output_button_cb(): arg none\n");
	}

output_format = OUTPUT_FORMAT_PPML;

/* save the state */
save_project_vars();

export_form_modified_flag = 1;
}/* end function export_form_enable_ppml_output_button_cb */


void export_form_enable_ppml_for_subtitler_yuv_output_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "export_form_enable_ppml_for_subtitler_yuv_output_button_cb(): arg none\n");
	}

output_format = OUTPUT_FORMAT_PPML_FOR_SUBTITLER_YUV;

/* save the state */
save_project_vars();

export_form_modified_flag = 1;
}/* end function export_form_enable_ppml_for_subtitler_yuv_output_button_cb */


void export_form_enable_suti_output_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "export_form_enable_suti_output_button_cb(): arg none\n");
	}

output_format = OUTPUT_FORMAT_SUTI;

/* save the state */
save_project_vars();

export_form_modified_flag = 1;
}/* end function export_form_enable_suti_output_button_cb */


void export_form_enable_ssa_output_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "export_form_enable_ssa_output_button_cb(): arg none\n");
	}

output_format = OUTPUT_FORMAT_SSA;

/* save the state */
save_project_vars();

export_form_modified_flag = 1;
}/* end function export_form_enable_ssa_output_button_cb */


void export_form_enable_srt_output_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "export_form_enable_srt_output_button_cb(): arg none\n");
	}

output_format = OUTPUT_FORMAT_SRT;

/* save the state */
save_project_vars();

export_form_modified_flag = 1;
}/* end function export_form_enable_srt_output_button_cb */


void export_form_enable_vplayer_output_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "export_form_enable_ssa_output_button_cb(): arg none\n");
	}

output_format = OUTPUT_FORMAT_VPLAYER;

/* save the state */
save_project_vars();

export_form_modified_flag = 1;
}/* end function export_form_enable_vplayer_output_button_cb */


void export_form_enable_submux_output_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "export_form_enable_submux_output_button_cb(): arg none\n");
	}

output_format = OUTPUT_FORMAT_SUBMUX;

/* save the state */
save_project_vars();

export_form_modified_flag = 1;
}/* end function export_form_enable_submux_output_button_cb */


void export_form_enable_submux_dvd_output_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "export_form_enable_submux_dvd_output_button_cb(): arg none\n");
	}

output_format = OUTPUT_FORMAT_SUBMUX_DVD;

/* save the state */
save_project_vars();

export_form_modified_flag = 1;
}/* end function export_form_enable_submux_dvd_output_button_cb */


void export_form_enable_ebu_stl_output_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "export_form_enable_ebu_stl_output_button_cb(): arg none\n");
	}

output_format = OUTPUT_FORMAT_EBU_STL;

/* save the state */
save_project_vars();

export_form_modified_flag = 1;
}/* end export_form_enable_ebu_stl_output_button_cb */


void export_form_enable_microdvdplayer_output_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "export_form_enable_microdvdplayer_output_button_cb(): arg none\n");
	}

output_format = OUTPUT_FORMAT_MICRO_DVD_PLAYER;

/* save the state */
save_project_vars();

export_form_modified_flag = 1;
}/* end function export_form_enable_microdvdplayer_output_button_cb */


void export_form_let_microdvdplayer_format_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "export_form_let_microdvdplayer_format_button_cb(): arg none\n");
	}

let_microdvdplayer_format_flag = fl_get_button(ob);

/* save the state */
save_project_vars();

export_form_modified_flag = 1;
}/* end function export_form_let_microdvdplayer_format_button_cb */


void export_form_enable_iauthor_output_button_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "export_form_enable_iauthor_output_button_cb(): arg none\n");
	}

output_format = OUTPUT_FORMAT_I_AUTHOR;

/* save the state */
save_project_vars();

export_form_modified_flag = 1;
}/* end function export_form_enable_iauthor_output_button_cb */


void export_form_fontsize_up_button_cb(FL_OBJECT *ob, long data)
{
int size;

fontsizes_modified_flag = 1;
if(export_form_fontsize < 5) export_form_fontsize++;
size = integer_to_fontsize(export_form_fontsize);

fl_set_object_lsize(fdui -> export_form_select_text, size);

save_fontsizes();
}/* end function export_form_fontsize_up_button_cb */


void export_form_fontsize_down_button_cb(FL_OBJECT *ob, long data)
{
int size;

fontsizes_modified_flag = 1;
if(export_form_fontsize > 0) export_form_fontsize--;
size = integer_to_fontsize(export_form_fontsize);

fl_set_object_lsize(fdui -> export_form_select_text, size);

save_fontsizes();
}/* end function export_form_fontsize_down_button_cb */


void export_form_cancel_button_cb(FL_OBJECT *ob, long data)
{
if(export_form_modified_flag)
	{
	/* restore from disc */
	load_general_settings();
	load_project_vars();

	export_form_modified_flag = 0;
 	}

fl_hide_form(fdui -> export_form);

/* restore from disc */
if(fontsizes_modified_flag)
	{
	load_fontsizes();
	fontsizes_modified_flag = 0;
	}

export_form_shown_flag = 0;

} /* end function export_cancel_button_cb */


void export_form_accept_button_cb(FL_OBJECT *ob, long data)
{

if(filename_error_flag)
	{
	fl_show_alert(\
	"Incorrect path filename", "for ppml header file.", "Fix it first.", 0);

	return;
	}

fl_hide_form(fdui -> export_form);

if(fontsizes_modified_flag)
	{
	save_fontsizes();

	fontsizes_modified_flag = 0;
	}

if(export_form_modified_flag)
	{
	save_general_settings();

	save_project_vars();

	export_form_modified_flag = 0;
	}


export_form_shown_flag = 0;

} /* end function export_form_accept_button_cb */


