/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xste.h"

FD_xste *fdui;


int show_fonts_form()
{
if(debug_flag)
	{
	printf("show_fonts_form(): arg none\n");
	}

if(fonts_form_shown_flag) return 1;

set_font_radio_buttons(fonts_mode);

show_fonts(SHOW_TOP);

fl_show_form(fdui -> fonts_form, FL_PLACE_CENTER, FL_TRANSIENT,\
"xste: fonts");

fonts_form_shown_flag = 1;

return 1;
} /* end function show_fonts_form */


void addit(const char *str)   
{  
char temp[1024];

//sprintf(temp, "@f@C0%s", str);
sprintf(temp, "@C0%s", str);

fl_add_browser_line(fdui -> fonts_form_browser, temp); 
} /* end function add_it */
 

int add_system_fonts()
{
int a, j, k;
FILE *pptr;
char temp[TEMP_SIZE];
FILE *fptr;
char str[16][80];
char *ptr;

if(debug_flag)
	{
	printf("add_system_fonts(): arg none\n");
	}

/* first add the xforms fonts to the structure */
max_fonts = fl_enumerate_fonts(add_xforms_font, 1);

/* execute xlsfonts */
sprintf(temp, "xlsfonts > %s/.xste/fontlist.txt", home_dir);
pptr = popen(temp, "r");
pclose(pptr);

/* read the created font list */
sprintf(temp, "%s/.xste/fontlist.txt", home_dir);
fptr = fopen(temp, "r");
if(! fptr)
	{
	fl_show_alert("Could not open file", temp, "No system fonts", 0);

	return 0;
	}

while(1)
	{
	/* closes file if EOF */
	a = readline(fptr, temp);
	if(a == EOF) break;

	/*
	-adobe-courier-bold-o-normal--10-100-75-75-m-60-iso8859-15
	 1     2       3    4 5     6 7  8   9  10 11 12 13     14
	*/

	ptr = temp;
	for(j = 0; j < 16; j++)
		{
		/* copy field */
		k = 0;
		while(1)
			{
			/* test for end of font */
			if(*ptr == 0) break;

			/* test for end of field */
			if(*ptr == '-') break;

			/* copy character */
			str[j][k] = *ptr;

			ptr++;
			k++;
			} /* end while all characters in a field */		

		/* string termination */
		str[j][k] = 0;

		if(debug_flag)
			{
			printf("add_system_fonts(): a=%d str[%d]=%s\n", a, j, str[j]);
			}

		/* end of font */
		if(*ptr == 0) break;

		/* point past '-' */
		ptr++;

		} /* end for all fields */

	/* some filters */

	/* only size 10 */
	if(atoi(str[7]) != 10) continue;

	/* only normal or recursive */	
	if(
	(strcmp(str[4], "r") != 0)
	&& (strcmp(str[4], "o") != 0)
	&& (strcmp(str[4], "i") != 0)
	)
		{
		continue;
		}

	/*
	-adobe-courier-bold-o-normal--10-100-75-75-m-60-iso8859-15
	 1     2       3    4 5     6 7  8   9  10 11 12 13     14
	-adobe-courier-*   -*-*     -*-*-?  -* -* -*-* -*      -*
	*/

	/* make a suitable entry for xforms */
	sprintf(temp, "-%s-%s-%s-%s-*-*-*-?-*-*-*-*-%s-%s",\
	str[1], str[2], str[3], str[4], str[13], str[14]);

	if(debug_flag)
		{
		printf("add_system_fonts(): adding=%s\n", temp);
		}
		
	/*
	add to structure first, xlsfonts seems to create double entries.
	keep iso8895 and 15 separate for use later in posting header and
    to select a font.
	*/
	add_X_font(temp, str[13], atoi(str[14]) );
	} /* end while all fonts in list */


sort_fonts();

/* 
enumerate browser_lines !!!, else lookup for font number in setup will fail.
*/
show_fonts(SHOW_TOP);

return 1;
} /* add function add_system_fonts */


int set_article_fonts(int font)
{
int a;
char *ptr;
char temp[80];
FILE *pptr;
int iso_number;
int iso_extention;

if(debug_flag)
	{
	printf("set_article_fonts(): arg font=%d using used_font=%d\n",\
	font, used_font);
	}

if(font == used_font)
	{
	if(debug_flag)
		{
		printf("set_article_fonts(): returning font=used_font\n");
		}

	return 1;
	}

/* set the global */
used_font = font;

/* get the iso info of the current used font */
ptr = line_to_iso(font, &iso_extention);
if(! ptr)
	{
	if(debug_flag)
		{
		printf("line_to_iso_failed\n");
		}

	return 0;
	}

if(debug_flag)
	{
	printf("set_article_fonts(): ISO ptr=%s\n", ptr);
	}

a = sscanf(ptr + 3, "%d", &iso_number);
if(strncasecmp(ptr, "ISO", 3) == 0)
	{
	sprintf(temp, "charset=ISO-%d-%d", iso_number, iso_extention);
	}
/* testing with non ISO too? */
//else if(strncasecmp(ptr, "koi", 3) == 0)
//	{
//	sprintf(temp, "charset=KOI-%d-%d", iso_number, iso_extention);
//	}
else
	{
	strcpy(temp, ""); 
	}

if(used_charset) free(used_charset);
used_charset = strsave(temp);
if(! used_charset) return 0;
if(debug_flag)
	{
	printf("set_article_fonts(): setting used_charset=%s\n", used_charset);
	}

if(font > 15)
	{
	ptr = line_to_font(font);
	if(! ptr)
		{
		fl_show_alert("could not set article font", "using default", "", 0);

		return 0;
		}

	if(debug_flag)
		{
		printf("set_article_fonts(): setting font 17 ptr=%p (%s) font=%d\n",\
		ptr, ptr, font);
 		}

	a = fl_set_font_name(17, ptr);
	if(a < 0)
		{
		fl_show_alert("fl_set_font_name() failed", "", "", 0);

		return 0;
		}

	/* use position 17 */
	font = 17;
	} /* end if requested font > 15 */

/* if font 0 selected */
if(font < 0) font = 0;

if(debug_flag)
	{
	printf("set_article_fonts(): setting articles lstyle for font=%d\n",\
	font);
	}

/* inputs */
fl_set_object_lstyle(fdui -> main_form_search_input_field, font);
fl_set_object_lstyle(fdui -> main_form_text_input_field, font);
fl_set_object_lstyle(fdui -> special_characters_form_input, font);

/* browser */
fl_set_browser_fontstyle(fdui -> main_form_browser, font);
fl_set_browser_fontstyle(fdui -> fonts_form_browser, font);

/* on some fonts text becomes invisible */

XSync(fl_get_display(), 0);

/* refresh the X screen to show the new fonts */
sprintf(temp, "xrefresh");
pptr = popen(temp, "w");
pclose(pptr);

return 1;
} /* end function set_article_fonts */


int set_global_fonts(int font)
{
int a;
char *ptr;
FILE *pptr;
char temp[80];

if(debug_flag)
	{
	printf("set_global_fonts(): arg font=%d\n", font);
	}

get_max_fonts(&a);
if(font > a)
	{
	printf(\
"error requested global font number %d to high, only %d fonts loaded\n",\
	font, a);
	}

if(font > 15)
	{
	ptr = line_to_font(font);
	if(! ptr)
		{
		sprintf(temp, "%d", font);
		fl_show_alert(\
		"could not set global font", temp, "using default", 0);

		return 0;
		}

	if(debug_flag)
		{
		printf("set_global_fonts(): setting font 16 ptr=%p (%s) font=%d\n",\
		ptr, ptr, font);
 		}

	a = fl_set_font_name(16, ptr);
	if(a < 0)
		{
		fl_show_alert("fl_set_font_name() failed", "", "", 0);

		return 0;
		}

	/* use position 16 */
	font = 16;
	} /* end if requested font > 15 */

/* if font 0 selected */
if(font < 0) font = 0;

if(debug_flag)
	{
	printf("set_gobal_fonts(): setting global lstyle for font=%d\n",\
	font);
	}

/* text in pull down menus */
fl_setpup_default_fontstyle(font);

/* pul down menus */
fl_set_object_lstyle(fdui -> main_form_file_menu, font);
//main_form_window_menu;

/* text outputs */ 
fl_set_object_lstyle(fdui -> main_form_outfield, font);

/* text form titles */
fl_set_object_lstyle(fdui -> main_form_title, font);
fl_set_object_lstyle(fdui -> project_form_title, font);
fl_set_object_lstyle(fdui -> export_form_title, font);
fl_set_object_lstyle(fdui -> export_form_select_text, font);
fl_set_object_lstyle(fdui -> fonts_form_title, font);
//fl_set_object_lstyle(fdui -> special_characters_form_form_title, font);

/* browsers */
fl_set_browser_fontstyle(fdui -> main_form_browser, font);
fl_set_browser_fontstyle(fdui -> project_form_browser, font);
fl_set_browser_fontstyle(fdui -> fonts_form_browser, font);

/* buttons */
fl_set_object_lstyle(fdui -> main_form_audio_mode_button, font);
fl_set_object_lstyle(fdui -> main_form_search_case_button, font);
fl_set_object_lstyle(fdui -> main_form_search_button, font);
fl_set_object_lstyle(fdui -> main_form_video_display_button, font);
fl_set_object_lstyle(fdui -> main_form_next_red_button, font);
fl_set_object_lstyle(fdui -> main_form_erase_all_empty_lines_button, font);
fl_set_object_lstyle(fdui -> main_form_edit_frame_list_button, font);
fl_set_object_lstyle(fdui -> main_form_spellcheck_input_button, font);
fl_set_object_lstyle(fdui -> main_form_delete_button, font);
fl_set_object_lstyle(fdui -> main_form_clear_button, font);
fl_set_object_lstyle(fdui -> main_form_add_button, font);
fl_set_object_lstyle(fdui -> main_form_text_hold_button, font);
fl_set_object_lstyle(fdui -> main_form_set_PAL_fps_button, font);
fl_set_object_lstyle(fdui -> main_form_set_NTSC_fps_button, font);
fl_set_object_lstyle(fdui -> main_form_play_button, font);
fl_set_object_lstyle(fdui -> main_form_auto_switch, font);
fl_set_object_lstyle(fdui -> main_form_output_switch, font);
fl_set_object_lstyle(fdui -> main_form_move_from_switch, font);
fl_set_object_lstyle(fdui -> main_form_play_part_button_frwd, font);
fl_set_object_lstyle(fdui -> main_form_play_part_button_rwd, font);
fl_set_object_lstyle(fdui -> main_form_play_part_button_fwd, font);
fl_set_object_lstyle(fdui -> main_form_play_part_button_ffwd, font);
fl_set_object_lstyle(fdui -> main_form_mem1_button, font);
fl_set_object_lstyle(fdui -> main_form_rcl_button, font);
fl_set_object_lstyle(fdui -> main_form_snap_button, font);
fl_set_object_lstyle(fdui -> main_form_frame_now_button, font);
fl_set_object_lstyle(fdui -> main_form_align_start_button, font);
fl_set_object_lstyle(fdui -> main_form_align_end_button, font);
fl_set_object_lstyle(fdui -> main_form_exit_switch, font);
fl_set_object_lstyle(fdui -> project_form_delete_button, font);
fl_set_object_lstyle(fdui -> project_form_add_button, font);
fl_set_object_lstyle(fdui -> export_form_enable_ppml_output_button, font);
fl_set_object_lstyle(fdui -> export_form_enable_suti_output_button, font);
fl_set_object_lstyle(fdui -> export_form_enable_vplayer_output_button, font);
fl_set_object_lstyle(fdui -> export_form_enable_ssa_output_button, font);

fl_set_object_lstyle(fdui -> export_form_accept_button, font);
fl_set_object_lstyle(fdui -> fonts_form_accept_button, font);
fl_set_object_lstyle(fdui -> project_form_accept_button, font);

fl_set_object_lstyle(fdui -> fonts_form_global_fonts_button, font);
fl_set_object_lstyle(fdui -> fonts_form_default_fonts_button, font);
fl_set_object_lstyle(fdui -> fonts_form_article_fonts_button, font);

fl_set_object_lstyle(fdui -> main_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> main_form_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> project_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> project_form_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> export_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> export_form_fontsize_down_button, font);
fl_set_object_lstyle(fdui -> fonts_form_fontsize_up_button, font);
fl_set_object_lstyle(fdui -> fonts_form_fontsize_down_button, font);

/* inputs */
//fl_set_object_lstyle(fdui -> main_form_frame_input_field, font);
//fl_set_object_lstyle(fdui -> main_form_current_frame_input_field, font);
//fl_set_object_lstyle(fdui -> main_form_text_duration_input_field, font);
//fl_set_object_lstyle(fdui -> main_form_frames_per_second_input_field, font);
//fl_set_object_lstyle(fdui -> main_form_special_character_input_field, font);
//fl_set_object_lstyle(fdui -> project_form_input_field, font);
//fl_set_object_lstyle(fdui -> export_form_fontsize_input_field, font);

/* misc */
//main_form_local_clock;
fl_set_object_lstyle(fdui -> main_form_volume_slider, font);

XSync(fl_get_display(), 0);

/* refresh the X screen to show the new fonts */
sprintf(temp, "xrefresh");
pptr = popen(temp, "w");
pclose(pptr);

return 1;
} /* end function set_global_fonts */


int set_font_radio_buttons(int mode)
{
switch(mode)
	{
	case ARTICLE_FONTS:
		fl_set_button(fdui -> fonts_form_article_fonts_button, 1);
		break;
	case GLOBAL_FONTS:
		fl_set_button(fdui -> fonts_form_global_fonts_button, 1);
		break;
	case DEFAULT_FONTS:
		fl_set_button(fdui -> fonts_form_default_fonts_button, 1);
		break;
	} /* end switch font_mode */		

return 1;
} /* end function set_font_radio_buttons */

