/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xste.h"

FD_xste *fdui;


void fonts_form_browser_cb(FL_OBJECT *ob, long data)
{
int selected_line;

if(debug_flag)
    {
    fprintf(stdout, "fonts_form_browser_cb():\n");
    }

selected_line = fl_get_browser(ob);
if(! selected_line) return;

switch(fonts_mode)
	{
	case GLOBAL_FONTS:
		selected_global_font = selected_line - 1;

		/* xforms hack */
		set_global_fonts(selected_global_font);
		break;
	case ARTICLE_FONTS:
		selected_articles_font = selected_line - 1;

		/* xforms hack */
		set_article_fonts(selected_articles_font);
		set_article_fonts(selected_articles_font);
		break;
	case DEFAULT_FONTS:
		selected_articles_font = 0;
		selected_global_font = 0;

		set_global_fonts(selected_global_font);
		set_article_fonts(selected_articles_font);
		break;
	default:
		break;
	} /* end switch fonts_mode */

show_fonts(SHOW_SAME_POSITION);

save_selected_fonts();
} /* end function fonts_form_browser_cb */


void fonts_form_browser_double_cb(FL_OBJECT *ob, long data)
{
if(debug_flag)
	{
	fprintf(stdout, "fonts_form_browser_double_cb():\n");
	}

}/* end function  fonts_form_list_browser_double_cb */


void fonts_form_global_fonts_button_cb(FL_OBJECT *ob, long data)
{
fonts_mode = GLOBAL_FONTS;

save_selected_fonts();
} /* end function fonts_form_global_fonts_button_cb */


void fonts_form_article_fonts_button_cb(FL_OBJECT *ob, long data)
{
fonts_mode = ARTICLE_FONTS;

save_selected_fonts();
} /* end function fonts_form_article_fonts_button_cb */


void fonts_form_default_fonts_button_cb(FL_OBJECT *ob, long data)
{
fonts_mode = DEFAULT_FONTS;

selected_articles_font = 0;
selected_global_font = 0;

set_global_fonts(selected_global_font);
set_article_fonts(selected_articles_font);

show_fonts(SHOW_SAME_POSITION);

save_selected_fonts();
} /* end function fonts_form_default_fonts_button_cb */


void fonts_form_fontsize_up_button_cb(FL_OBJECT *ob, long data)
{
int size;

if(fonts_form_fontsize < 5) fonts_form_fontsize++;
size = integer_to_fontsize(fonts_form_fontsize);

//fl_set_browser_fontsize(fdui -> fonts_form_browser, size);

save_fontsizes();

/* this sets the actual size */
load_fontsizes();
}/* end function fonts_form_fontsize_up_button_cb */


void fonts_form_fontsize_down_button_cb(FL_OBJECT *ob, long data)
{
int size;

if(fonts_form_fontsize > 0) fonts_form_fontsize--;
size = integer_to_fontsize(fonts_form_fontsize);

//fl_set_browser_fontsize(fdui -> fonts_form_browser, size);

save_fontsizes();

/* this sets the actual size */
load_fontsizes();
}/* end function fonts_form_fontsize_down_button_cb */


void fonts_form_accept_button_cb(FL_OBJECT *ob, long data)
{
fl_hide_form(fdui -> fonts_form);

fonts_form_shown_flag = 0;
}/* end function fonts_form_accept_button_cb */


