/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xste.h"

/* for YUV to RGB */
#define LIMIT(x) ((((x)>0xffffff)?0xff0000:(((x)<=0xffff)?0:(x)&0xff0000))>>16)

FD_xste *fdui;

static int global_subtitle_palette_form_modified_flag;
static int fontsizes_modified_flag;

static int red, green, blue;
static int selected_button = -1;


void global_subtitle_palette_form_color_slider_red_cb(FL_OBJECT *ob, long data)
{
if(selected_button == -1) return;

red = (int) fl_get_slider_value(ob);

fl_mapcolor(FL_FREE_COL1 + selected_button, red, green, blue);

xste_rgb_palette[selected_button][0] = red;

global_subtitle_palette_form_set_color_button(selected_button);

set_color_circle(red, green, blue);
} /* end function global_subtitle_palette_form_color_slider_red_cb */


void global_subtitle_palette_form_color_slider_green_cb(FL_OBJECT *ob, long data)
{
if(selected_button == -1) return;

green = (int) fl_get_slider_value(ob);

fl_mapcolor(FL_FREE_COL1 + selected_button, red, green, blue);

xste_rgb_palette[selected_button][1] = green;

global_subtitle_palette_form_set_color_button(selected_button);

set_color_circle(red, green, blue);
} /* end function global_subtitle_palette_form_color_slider_green_cb */


void global_subtitle_palette_form_color_slider_blue_cb(FL_OBJECT *ob, long data)
{
if(selected_button == -1) return;

blue = (int) fl_get_slider_value(ob);

fl_mapcolor(FL_FREE_COL1 + selected_button, red, green, blue);

xste_rgb_palette[selected_button][2] = blue;

global_subtitle_palette_form_set_color_button(selected_button);

set_color_circle(red, green, blue);
} /* end function global_subtitle_palette_form_color_slider_green_cb */


void global_subtitle_palette_form_color0_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 0;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color0_button_cb */


void global_subtitle_palette_form_color1_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 1;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color1_button_cb */


void global_subtitle_palette_form_color2_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 2;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color2_button_cb */


void global_subtitle_palette_form_color3_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 3;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color3_button_cb */


void global_subtitle_palette_form_color4_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 4;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color4_button_cb */


void global_subtitle_palette_form_color5_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 5;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color5_button_cb */


void global_subtitle_palette_form_color6_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 6;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color6_button_cb */


void global_subtitle_palette_form_color7_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 7;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color7_button_cb */


void global_subtitle_palette_form_color8_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 8;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color8_button_cb */


void global_subtitle_palette_form_color9_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 9;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color9_button_cb */


void global_subtitle_palette_form_color10_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 10;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color10_button_cb */


void global_subtitle_palette_form_color11_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 11;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color11_button_cb */


void global_subtitle_palette_form_color12_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 12;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color12_button_cb */


void global_subtitle_palette_form_color13_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 13;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color13_button_cb */


void global_subtitle_palette_form_color14_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 14;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color14_button_cb */


void global_subtitle_palette_form_color15_button_cb(FL_OBJECT *ob, long data)
{
selected_button = 15;

set_color_sliders(selected_button);

global_subtitle_palette_form_modified_flag = 1;
} /* end function global_subtitle_palette_form_color15_button_cb */


void global_subtitle_palette_form_defaults_button_cb(FL_OBJECT *ob, long data)
{
if(! set_global_subtitle_palette_defaults() ) return;

global_subtitle_palette_form_modified_flag = 1;
} /* end function void global_subtitle_palette_form_defaults_button_cb */


void global_subtitle_palette_form_color_circle_dial_cb(FL_OBJECT *ob, long data)
{
double color_circle_dial_degrees;
char temp[80];
int y, u, v;
double dsaturation;
int cy, cr, cg, cb;
double du, dv;

dsaturation = 1.0;
color_circle_dial_degrees = fl_get_dial_value(ob);

sprintf(temp, "%.02f", color_circle_dial_degrees);
fl_set_input(fdui -> global_subtitle_palette_form_color_circle_input, temp);

/* angle to rgb */
/* demodulate :) our quadrature demodulator */

color_circle_dial_degrees /= (180.0 / M_PI);

du = sin(color_circle_dial_degrees) * dsaturation;
dv = -cos(color_circle_dial_degrees) * dsaturation;

u = du * 255.0;
v = dv * 255.0;

/* yuv to rgb */
/* lot of white */
y = 200;
cy = y - 16;
cy  *= 76310;

cr = 104635 * v;
cg = -25690 * u + -53294 * v;
cb = 132278 * u;

red = LIMIT(cr + cy);
green = LIMIT(cg + cy);
blue =  LIMIT(cb + cy);

/* test if a button selected */
if(selected_button < 0) return;

fl_set_slider_value(fdui -> global_subtitle_palette_form_color_slider_red, red);
fl_set_slider_value(fdui -> global_subtitle_palette_form_color_slider_green, green);
fl_set_slider_value(fdui -> global_subtitle_palette_form_color_slider_blue, blue);

xste_rgb_palette[selected_button][0] = red;
xste_rgb_palette[selected_button][1] = green;
xste_rgb_palette[selected_button][2] = blue;

fl_mapcolor(FL_FREE_COL1 + selected_button, red, green, blue);

global_subtitle_palette_form_set_color_button(selected_button);

} /* end function global_subtitle_palette_form_color_circle_dial_cb */


void global_subtitle_palette_form_color_circle_input_cb(FL_OBJECT *ob, long data)
{
} /* end function global_subtitle_palette_form_color_circle_input_cb */


void global_subtitle_palette_form_fontsize_up_button_cb(FL_OBJECT *ob, long data)
{
int size;

fontsizes_modified_flag = 1;
if(global_subtitle_palette_form_fontsize < 5) global_subtitle_palette_form_fontsize++;
size = integer_to_fontsize(global_subtitle_palette_form_fontsize);

//fl_set_object_lsize(fdui -> global_subtitle_palette_form_input, size);

save_fontsizes();

} /* end function global_subtitle_palette_form_fontsize_up_button_cb */


void global_subtitle_palette_form_fontsize_down_button_cb(FL_OBJECT *ob, long data)
{
int size;

fontsizes_modified_flag = 1;
if(global_subtitle_palette_form_fontsize > 0) global_subtitle_palette_form_fontsize--;
size = integer_to_fontsize(global_subtitle_palette_form_fontsize);

//fl_set_object_lsize(fdui -> global_subtitle_palette_form_input, size);

save_fontsizes();

} /* end function global_subtitle_palette_form_fontsize_down_button_cb */


void global_subtitle_palette_form_cancel_button_cb(FL_OBJECT *ob, long data)
{
if( global_subtitle_palette_form_modified_flag)
	{
	/* restore from disc */
	load_general_settings();
	load_project_vars();

	global_subtitle_palette_form_modified_flag = 0;
 	}

fl_hide_form(fdui -> global_subtitle_palette_form);

if(fontsizes_modified_flag)
	{
	/* restore from disc */
	load_fontsizes();
	fontsizes_modified_flag = 0;
	}

global_subtitle_palette_form_shown_flag = 0;

} /* end function global_subtitle_palette_form_cancel_button_cb */


void global_subtitle_palette_form_accept_button_cb(FL_OBJECT *ob, long data)
{
int i;

if(global_subtitle_palette_form_modified_flag)
	{
	save_general_settings();

	if(debug_flag)
		{
		for(i = 0; i < 16; i++)
			{
			fprintf(stdout,\
			"xste_rgb_palette[i][0]=%d xste_rgb_palette[i][1]=%d xste_rgb_palette[i][2]=%d\n",\
			xste_rgb_palette[i][0], xste_rgb_palette[i][1], xste_rgb_palette[i][2]);
			}
		}

	save_project_vars();

	global_subtitle_palette_form_modified_flag = 0;
	}

fl_hide_form(fdui -> global_subtitle_palette_form);

if(fontsizes_modified_flag)
	{
	save_fontsizes();

	save_general_settings();
	save_project_vars();

	fontsizes_modified_flag = 0;
	}

global_subtitle_palette_form_shown_flag = 0;
} /* end function global_subtitle_palette_form_accept_button_cb */


int set_color_sliders(int selected)
{

red =   xste_rgb_palette[selected][0];
green = xste_rgb_palette[selected][1];
blue =  xste_rgb_palette[selected][2];

fl_set_slider_value(fdui -> global_subtitle_palette_form_color_slider_red, red);
fl_set_slider_value(fdui -> global_subtitle_palette_form_color_slider_green, green);
fl_set_slider_value(fdui -> global_subtitle_palette_form_color_slider_blue, blue);

return 1;
} /* end function set_color_sliders */


int set_global_subtitle_palette_defaults()
{
if(debug_flag)
	{
	fprintf(stdout, "set_global_subtitle_palette_defaults(): arg none\n");	
	}

if(! fl_show_question("This will set all color in global palette to default values, OK?", 0) ) return 0; 

xste_rgb_palette[0][0] = 0; // r  background, transparent
xste_rgb_palette[0][1] = 0; // g
xste_rgb_palette[0][2] = 0; // b

xste_rgb_palette[1][0] = 235; // body, opague
xste_rgb_palette[1][1] = 235;
xste_rgb_palette[1][2] = 235;

xste_rgb_palette[2][0] = 16; // outline1, opague
xste_rgb_palette[2][1] = 16;
xste_rgb_palette[2][2] = 16; 

xste_rgb_palette[3][0] = 255; // outline2, transparent
xste_rgb_palette[3][1] = 255;
xste_rgb_palette[3][2] = 255;

xste_rgb_palette[4][0] = 255;
xste_rgb_palette[4][1] = 0;
xste_rgb_palette[4][2] = 0;

xste_rgb_palette[5][0] = 0;
xste_rgb_palette[5][1] = 255;
xste_rgb_palette[5][2] = 0;

xste_rgb_palette[6][0] = 0;
xste_rgb_palette[6][1] = 0;
xste_rgb_palette[6][2] = 255;

xste_rgb_palette[7][0] = 255;
xste_rgb_palette[7][1] = 255;
xste_rgb_palette[7][2] = 0;

xste_rgb_palette[8][0] = 255;
xste_rgb_palette[8][1] = 0;
xste_rgb_palette[8][2] = 255;

xste_rgb_palette[9][0] = 0;
xste_rgb_palette[9][1] = 255;
xste_rgb_palette[9][2] = 255;

xste_rgb_palette[10][0] = 235;
xste_rgb_palette[10][1] = 138;
xste_rgb_palette[10][2] = 0;

xste_rgb_palette[11][0] = 32;
xste_rgb_palette[11][1] = 217;
xste_rgb_palette[11][2] = 255;

xste_rgb_palette[12][0] = 81;
xste_rgb_palette[12][1] = 169;
xste_rgb_palette[12][2] = 45;

xste_rgb_palette[13][0] = 253;
xste_rgb_palette[13][1] = 189;
xste_rgb_palette[13][2] = 0;

xste_rgb_palette[14][0] = 255;
xste_rgb_palette[14][1] = 245;
xste_rgb_palette[14][2] = 173;

xste_rgb_palette[15][0] = 125;
xste_rgb_palette[15][1] = 125;
xste_rgb_palette[15][2] = 129;

if(! global_subtitle_palette_form_set_all_color_buttons() ) return 0;

global_subtitle_palette_form_modified_flag = 1;

return 1;
} /* end function set_global_subtitle_palette_defaults */



