/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
Wrote this to be able to create output files for I-Author
(windows!!) SVCD subtitler multiplexer, sort of replaces I-Authors
OGTEDITOR.
JP
*/

/*
Subtitles
The format of the file generated by I-Author's OGT editor is:

*******wik-ia3.txt CREATED BY OGTEDITOR 1.0
*******DATE:Thursday, August 15, 2002
************************************************************************

BMPFILE: wik-ia30000.BMP

STARTTIME: 61.1

TIME: 61.1 SETCOLOR Primary 0, 16, 128, 128

TIME: 61.1 SETCOLOR Primary 1, 233, 128, 128

TIME: 61.1 SETCOLOR Primary 2, 48, 184, 110

TIME: 61.1 SETCOLOR Primary 3, 80, 81, 91

TIME: 61.1 SETCOLOR Highlight 0, 16, 128, 128

TIME: 61.1 SETCOLOR Highlight 1, 209, 146, 17

TIME: 61.1 SETCOLOR Highlight 2, 81, 239, 91

TIME: 61.1 SETCOLOR Highlight 3, 144, 35, 54

TIME: 61.1 region 60, 409 to 659, 528

TIME: 61.1 SETBLEND Primary 0, 15, 15, 15

TIME: 61.1 SETBLEND Hightlight 0, 15, 15, 15

TIME: 61.1 FIELDINDEX 0, 1

TIME: 61.1 ENABLE_OGT

TIME: 183.61 DISABLE_OGT

************ Page #0 Finished***************

BMPFILE: wik-ia30001.BMP

repeats for every bitmap / entry.
times seems to be in seconds (float)
First entry start must be > 4 sec???
Current entry must end before next one starts.

4 bits per pixel bitmap, with 16 entry color pallette,
In the bitmap hsize, vsize, length and fle lenght field are used!

In this example, from DVB-s, 720 x 576, reduced with transcode
to 480x576 SVCD standard, it seems 720 is still used as width!
The bitmaps here are 600 x 120 (reported in xv),
starting at 60, 409, ending at 659, 528 (why is this not 660, 529 ?? 
*/


#include "xste.h"

FD_xste *fd_main_form;
extern FD_xste *fdui;


int write_iauthor_list()
{
int i;
struct frame *pa;
struct frame *pnext, *ptemp;
FILE *fptr;
char *ptr;
char temp[4096];
int next_frame_start;
long lthousands;
int text_end_frame;
double dstart_second, dend_second;
int xstart, xend, ystart, yend;

if(debug_flag)
	{
	printf("write_iauthor_list(): arg none\n");
	}

/*
.txt is as made by I-Author's OGT editor, and used by the I-Author
multiplexer.
*/

sprintf(temp, "%s/%s/%s/%s.txt",\
home_dir, selected_data_directory, selected_project, selected_project);
fptr = fopen(temp, "w");
if(! fptr)
	{
	fl_show_alert(\
		"write_iauthor_list", "Could not open for write", temp, 1);

	return 0;
	}

fprintf(fptr, "******* I-Author OGT format by %s\r\n", VERSION);

ptr = get_universal_time_as_string();
if(! ptr) return 0;

fprintf(fptr, "*******DATE: %s\r\n", ptr);

fprintf(fptr,\
"************************************************************************\r\n\r\n");

for(pa = frametab[0]; pa != 0; pa = pa -> nxtentr)
	{
	/*
	do not print negative frames, this results in negative times.
	*/
	if( atoi(pa -> name) < 0) continue;

	/* normal situation */
	text_end_frame = pa -> end_frame;

	/* get pointer to next structure entry */ 
	if(pa -> nxtentr) 
		{
		pnext = pa -> nxtentr;	
		
		/* find next line that is not a '*' comand line */
		while(pnext)
			{
			if(pnext -> text[0] != '*') break;

			if(pnext -> nxtentr)
				{	
				ptemp = pnext -> nxtentr;

				pnext = ptemp;
				}	
			} /* end while looking for non '*' entry */ 

		if(pnext)
			{
			/* get the start of the next frame */ 
			next_frame_start = atoi(pnext -> name);
		
			/* test if the current frame ends before the start of the next */
			if(pa -> end_frame > next_frame_start)
				{
				text_end_frame = next_frame_start;
				} /* end if frame ends before next one starts */ 
			}

		} /* end if not last entry */	
	
	/* we have this data at our disposal */ 
	//	char *name;/* this is the start frame */
	//	char *text;
	//	int end_frame; /* this is the end frame */
 
	/* calculate dstart_second */
	lthousands = atoi(pa -> name) * dmilli_seconds_per_frame;
	dstart_second = lthousands / 1000.0;

	/* calculate dend_second */
	lthousands = text_end_frame * dmilli_seconds_per_frame;
	dend_second = lthousands / 1000.0;

	/*
	do not print negative frames, this results in negative times,
	not sure I-Authors multiplexer likes that.
	*/
	if(dstart_second < 0) continue;
	
	/* do not print xste command lines in the form '*command' */
	if(pa -> text[0] == '*') continue;

	/* skip comment lines */
	if(pa -> text[0] == ';') continue;

	draw_mode = DRAW_MODE_OGT;

	if(! create_bitmap_file(pa) )
		{
		/* skip unprintable text (zero size and such) */
		continue;
		}

//	BMPFILE: wik-ia30000.BMP
	fprintf(fptr,\
	"BMPFILE: frame%04d.bmp\r\n\r\n", atoi(pa -> name) );

//	STARTTIME: 61.1
	fprintf(fptr, "STARTTIME: %.1f\r\n\r\n", dstart_second);

//	TIME: 61.1 SETCOLOR Primary 0, 16, 128, 128
//	TIME: 61.1 SETCOLOR Primary 1, 233, 128, 128
//	TIME: 61.1 SETCOLOR Primary 2, 48, 184, 110
//	TIME: 61.1 SETCOLOR Primary 3, 80, 81, 91
	for(i = 0; i < 4; i++)
		{
		fprintf(fptr,\
		"TIME: %.1f SETCOLOR Primary %d, %d, %d, %d\r\n\r\n",\
		dstart_second, i,\
		xste_rgb_palette[i][0], xste_rgb_palette[i][1],xste_rgb_palette[i][2]); // rgb
		}

//	TIME: 61.1 SETCOLOR Highlight 0, 16, 128, 128
//	TIME: 61.1 SETCOLOR Highlight 1, 209, 146, 17
//	TIME: 61.1 SETCOLOR Highlight 2, 81, 239, 91
//	TIME: 61.1 SETCOLOR Highlight 3, 144, 35, 54
	for(i = 0; i < 4; i++)
		{
		fprintf(fptr,\
		"TIME: %.1f SETCOLOR Highlight %d, %d, %d, %d\r\n\r\n",\
		dstart_second, i,\
		xste_rgb_palette[i + 4][0], xste_rgb_palette[i + 4][1],xste_rgb_palette[i + 4][2]); // rgb
		}

	/*
	NOTE:
	xv reports the bitmap as 600 x 120, why the -1 for the end pos????
	*/
	xstart = pa -> xpos;
	ystart = pa -> ypos; 
	xend = pa -> width + pa -> xpos - 1;
	yend = pa -> height + pa -> ypos - 1;
	
	/* NOTE: strings mux.exe shows both a REGION and HLREGION */
//	TIME: 61.1 region 60, 409 to 659, 528
	fprintf(fptr, "TIME: %.1f REGION %d, %d to %d, %d\r\n\r\n",\
	dstart_second, xstart, ystart, xend, yend);

	fprintf(fptr, "TIME: %.1f HLREGION %d, %d to %d, %d\r\n\r\n",\
	dstart_second, xstart, ystart, xend, yend);

//	TIME: 61.1 SETBLEND Primary 0, 15, 15, 15
	fprintf(fptr, "TIME: %.1f SETBLEND Primary %d, %d, %d, %d\r\n\r\n",\
	dstart_second,\
	pa -> background_contrast, pa -> pattern_contrast, pa -> emphasis1_contrast, pa -> emphasis2_contrast);	

//	TIME: 61.1 SETBLEND Hightlight 0, 15, 15, 15
	fprintf(fptr, "TIME: %.1f SETBLEND Hightlight %d, %d, %d, %d\r\n\r\n",\
	dstart_second,\
	pa -> background_contrast, pa -> pattern_contrast, pa -> emphasis1_contrast, pa -> emphasis2_contrast);
	/* do not have a second contrast in xste! */

//	TIME: 61.1 FIELDINDEX 0, 1
	fprintf(fptr, "TIME: %.1f FIELDINDEX 0, 1\r\n\r\n", dstart_second);

//	TIME: 61.1 ENABLE_OGT
	fprintf(fptr, "TIME: %.1f ENABLE_OGT\r\n\r\n", dstart_second);

//	TIME: 183.61 DISABLE_OGT
	fprintf(fptr, "TIME: %.1f DISABLE_OGT\r\n\r\n", dend_second);

	fprintf(fptr, "************ Page #%d Finished***************\r\n\r\n",\
	atoi(pa -> name) );
	} /* end for all frames */

/* close the file */
fclose(fptr);

return 1;
}/* end function write_iauthor_list */

