/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
~*/


#include "xste.h"

extern FD_xste *fdui;
extern FD_xste *fd_main_form;

FL_APPEVENT_CB optimize_idle_cb;

static int one_liner_flag;


int idle_cb(XEvent *ev, void *data)
{
char temp[512];
char temp2[512];
FILE *pptr;
static int play_button_mode;
int status;
int seconds;
unsigned long lthousands;
int hour;
int minute;
int second;
int tenth;
static unsigned long counter;
unsigned long lstart_usecs, lcurrent_usecs, ldiff_usecs;
static int old_selected_picture;
static int old_play_button = 0;
struct frame *pa;

if(! allow_idle_cb) return 1;

/*
This will kill any zombies left when xste_audio audio player is destroyed.
*/
waitpid (WAIT_ANY, &status, WNOHANG);

if(play_right_mouse_flag)
	{
	if(current_frame < (selected_start_frame + (dframes_per_second * RIGHT_MOUSE_PLAY_SECONDS) ) )
		{
		play_button = 1;
		}
	else
		{
		play_right_mouse_flag = 0;
		play_button = 0;
		}
	}
else
	{
	play_button = fl_get_button(fdui -> main_form_play_button);
	}

if(play_button)
	{
	if(play_button_mode == 0)
		{
		gettimeofday(start_timeval, NULL);

		/* calculate end sample, play all of it */
		seconds = 36000;
		selected_end_sample =\
			selected_start_sample + (seconds * audio_sample_speed);

		if(synthesize_flag)
			{
			sprintf(temp, "%d", selected_start_frame);

			pa = lookup_frame(temp);	
			if(! pa) return 0;

			if( atoi(pa -> name) < 0) return 0;

			if(! pa -> text) return 0;

			if(pa -> text[0] == 0) return 0;
			if(pa -> text[0] == '*') return 0;

			speak_text(pa -> text); 
			}
		else
			{
			if(audio_mode == AUDIO_RAW)
				{
				if(! play_audio_raw(selected_start_sample, selected_end_sample) ) return 0;
				}
			else if(audio_mode == AUDIO_WAV)
				{
				if(! play_audio_wav(selected_start_sample, selected_end_sample) ) return 0;
				}
			else if(audio_mode == AUDIO_MP3)
				{
				if(! play_audio_mp3(selected_start_frame) ) return 0;
				}
			}

		} /* end if play_button_mode 0 */

	/* get elapsed time */
	gettimeofday(current_timeval, NULL);

	/* calculate time from moment play button was pressed */
	lcurrent_usecs =\
	current_timeval -> tv_usec + (1000000 * current_timeval -> tv_sec);

	lstart_usecs =\
	start_timeval -> tv_usec + (1000000 * start_timeval -> tv_sec);

	ldiff_usecs = lcurrent_usecs - lstart_usecs;

	/* calculate frames since play button was pressed */
	current_frame = ldiff_usecs / (dmilli_seconds_per_frame * 1000.0);
		
	/* calculate frames from start file */
	current_frame += selected_start_frame;

	/* 
	make selected_picture the current frame,
	video_player thread will see the change and display the new picture.
	*/
	selected_picture = current_frame;
	
	if(debug_flag)
		{
		fprintf(stdout,\
		"idle_cb(): selected_picture=%lu current_frame=%d\n",\
		selected_picture, current_frame);
		}

	if(show_video_flag)
		{
		/* signal to video thread that a new picture is present */
		if(selected_picture != old_selected_picture)
			{
			old_selected_picture = selected_picture;
			}	
		}

	/* 
	set the Now input field (actually only output) to the current frame
	played.
	*/
	set_current_frame_input(current_frame);

	/* prevent button from getting sticky */
	XSync(fl_get_display(), 0);

	play_button_mode = 1;

	}
else /* ! play button */
	{
	if(play_button_mode == 1)
		{
		if(synthesize_flag)
			{
			/* apllication to kill to stop sound depends on playback program used in xste_synthesize */
			
			temp[0] = 0;
//			sprintf(temp, "killall vplay");
			}
		else
			{
			if(audio_mode == AUDIO_RAW)
				{
				sprintf(temp, "killall xste_audio");
				}
			else if(audio_mode == AUDIO_WAV)
				{
				sprintf(temp, "killall xste_audio");
				}
			else if(audio_mode == AUDIO_MP3)
				{
				sprintf(temp, "killall mpg123");
				}

			}
		pptr = popen(temp, "r");
		pclose(pptr);
		}

	/* reset video display to the entry clicked in the browser */
	selected_picture = clicked_picture / 8;

	play_button_mode = 0;

	if(one_liner_flag)
		{
		fl_hide_oneliner();
		one_liner_flag = 0;
		}

	} /* end if ! play button */

//if(counter <= 0)
	{
	/* calcule hour, minute, second, tenth */
//	lthousands = current_frame * dmilli_seconds_per_frame;
	lthousands = selected_start_frame * dmilli_seconds_per_frame;

	hour = lthousands / 3600000;
	lthousands -= hour * 3600000; 

	minute = lthousands / 60000;
	lthousands -= minute * 60000;
	
	second = lthousands / 1000;
	lthousands -= second * 1000;

	tenth = lthousands / 100;

	sprintf(temp,\
	"start_frame=%d end_frame=%d time=%d:%02d:%02d:%1d",\
	selected_start_frame, selected_end_frame,\
	hour, minute, second, tenth);

	fl_set_object_label(fdui -> main_form_outfield, temp);

	/* reload counter */
	counter = 10;
	} /* end if counter == 0 */
	
/* decrement counter */
counter --;

if(show_video_flag && (video_error != VIDEO_OK) )
	{
	sprintf(temp,\
	"%s/.subtitles/%s/frame.%lu.jpg\n",\
	home_dir, selected_project, selected_picture);

	if(video_error == VIDEO_NO_OPEN)
		{
		fl_show_alert(\
		"video player could not find", "picture number", temp, 1);  
		}
	else if(video_error == VIDEO_NO_XBUFFER)
		{
		fl_show_alert("video player", "could not get xbuffer", "", 1);
		}
	else if(video_error == VIDEO_NO_JPG_DECODE)
		{
		fl_show_alert("video player", "jpg decode failed of", temp, 1);
		}

	/* prevent loop */
	video_error = VIDEO_OK;
	} /* end if video_error */ 

if(size_error_flag)
	{
	size_error_flag = 0;
	fl_show_alert("WARNING", "image does not fit", "top line out of screen area", 0);
	}

if(preview_flag && video_in_preview_flag && (video_error != VIDEO_OK) )
	{
	if(video_error == VIDEO_NO_FILENAME)
		{
		sprintf(temp, "No video filename specified");
		}
	if(video_error == VIDEO_NO_VIDEO)
		{
		sprintf(temp, "%s is not a video file", video_filename);
		}
	if(video_error == VIDEO_NO_OPEN)
		{
		sprintf(temp, "mpeg3lib had a problem opening %s", video_filename);
		}
	if(video_error == VIDEO_NO_STREAMS)
		{
		sprintf(temp, "No video stream found in %s", video_filename);
		}
	if(video_error == VIDEO_NO_SIZE)
		{
		sprintf(temp,\
		"%d x %d is not a usable size", video_file_width, video_file_height);
		}
	if(video_error == VIDEO_FPS)
		{
		sprintf(temp,\
		"fps %.3f is different from %.3f specified in main form\nthis will give timing errors",\
		video_file_fps, dframes_per_second);
		}
	if(video_error == VIDEO_SIZE_TOO_BIG)
		{
		sprintf(temp, "Video size %d x %d is too big, change in main form.", h_size, v_size);
		}
	if(video_error == VIDEO_SIZE_ZERO)
		{
		sprintf(temp, "Illegal video size %d x %d in %s", h_size , v_size, video_filename); 
		}
	if(video_error == VIDEO_SIZE_DIFFERENT)
		{
		sprintf(temp,\
		"Video size %d x %d not equal selected display size %d x %d, set in main form.",\
		video_file_width, video_file_height, h_size, v_size);
		}

#ifdef ALLOW_ERROR_MESSAGES_IN_IDLE_CB
	fl_show_alert("ERROR", video_filename, temp, 0);
#else
	sprintf(temp2, "ERROR: %s", temp);	
	fl_show_oneliner(temp2, 20, 300);
	one_liner_flag = 1;
#endif

	video_in_preview_flag = 0;
	fl_set_button(fdui -> main_form_video_in_preview_button, video_in_preview_flag);

	video_error = VIDEO_OK;
	new_preview_flag = 0;
	}


/* 
if project vars were loaded from disk, this flag is set
for example in case of program start, or a new project selection.
Only do this once, then wait for the flag again.
*/
if(select_frame_list_entry_flag)
	{
	select_frame_list_entry();

	select_frame_list_entry_flag = 0;
	}

if(play_button)
	{
	if(old_play_button != play_button) play_start_flag = 1;

	}

old_play_button = play_button;

return 1;
} /* end function idle_cb */

