/* 
xste subtitle editor
xste  is copyright (C) 2000 <Jan Panteltje>
email: panteltje@yahoo.com

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "xste.h"

extern FD_xste *fdui;

static int fontsizes_modified_flag;
int new_project_flag;

int project_form_modified_flag;

void project_form_input_field_cb(FL_OBJECT *ob, long data)
{
project_form_modified_flag = 1;
}/* end function project_form_input_field_cb */


void project_form_browser_cb(FL_OBJECT *ob, long data)
{
int selected_line;

if(debug_flag)
	{
	fprintf(stdout, "project_form_browser_cb():\n");
	}

selected_line = fl_get_browser(ob);
if(! selected_line) return;

/* maintain visible indication that line is selected with single click  */
fl_select_browser_line(fdui -> project_form_browser, abs(selected_line) );

/*project_form_modified_flag = 1;*/
}/* end function  project_form_browser_cb */


void project_form_browser_double_cb(FL_OBJECT *ob, long data)
{
int selected_line;
char *ptr;

if(debug_flag)
	{
	fprintf(stdout, "project_form_browser_double_cb():\n");
	}

selected_line = fl_get_browser(ob);
if(! selected_line) return;

ptr = line_to_project(abs(selected_line) );
if(!ptr) return;

select_project(ptr);

if(debug_flag)
	{
	fprintf(stdout,\
	"project_form_browser_double_cb():\n\
	selected=%s\n",\
	selected_project);
	}

show_projects(SHOW_SAME_POSITION);

fl_select_browser_line(fdui -> project_form_browser, abs(selected_line) );

project_form_modified_flag = 1;
}/* end function  project_form_browser_double_cb */


void project_form_delete_button_cb(FL_OBJECT *ob, long data)
{
int total_lines;
int s_line;
char *name;

total_lines = fl_get_browser_maxline(fdui -> project_form_browser);
for(s_line = 1; s_line <= total_lines; s_line++)
	{
	if(fl_isselected_browser_line(fdui -> project_form_browser, s_line) )
		{
		project_form_modified_flag = 1;

		name = (char *) line_to_project(s_line);
		if(name) delete_a_project(name);

		}/* end selected line */
	}/* end for all lines */

show_projects(SHOW_SAME_POSITION);

project_form_modified_flag = 1;
}/* end function project_form_delete_button_cb */


void project_form_add_button_cb(FL_OBJECT *ob, long data)
{
int s_line;
char *ptr;

if(debug_flag)
	{
	fprintf(stdout, "project_form_add_button_cb(): arg none\n");
	}

ptr = (char *) fl_get_input(fdui -> project_form_input_field);
if(! ptr) return;

if(! add_project(ptr) ) return;

/* clear the input field */
/*fl_set_input(fdui -> project_form_input_field, "");*/

show_projects(SHOW_BOTTOM);

/* mark new entry in browser */
project_to_line(ptr, &s_line);
fl_select_browser_line(fdui -> project_form_browser, s_line);

new_project_flag = 1;
project_form_modified_flag = 1;
}/* end function project_form_add_button_cb */


void project_form_fontsize_up_button_cb(FL_OBJECT *ob, long data)
{
int size;

if(project_form_fontsize < 5) project_form_fontsize++;
size = integer_to_fontsize(project_form_fontsize);

fl_set_browser_fontsize(fdui -> project_form_browser, size);
fl_set_object_lsize(fdui -> project_form_input_field, size);

fontsizes_modified_flag = 1;
}/* end function project_form_fontsize_up_button_cb */


void project_form_fontsize_down_button_cb(FL_OBJECT *ob, long data)
{
int size;

if(project_form_fontsize > 0) project_form_fontsize--;
size = integer_to_fontsize(project_form_fontsize);

fl_set_browser_fontsize(fdui -> project_form_browser, size);
fl_set_object_lsize(fdui -> project_form_input_field, size);

fontsizes_modified_flag = 1;
}/* end function project_form_fontsize_down_button_cb */


void project_form_cancel_button_cb(FL_OBJECT *ob, long data)
{
if(project_form_modified_flag)
	{
	/* restore from disc */
/*	load_projects();*/
	fl_set_input(fdui -> project_form_input_field, "");
	project_form_modified_flag = 0;
 	}

fl_hide_form(fdui -> project_form);

/* restore from disc */
if(fontsizes_modified_flag)
	{
	load_fontsizes();
	fontsizes_modified_flag = 0;
	}

project_form_shown_flag = 0;
}/* end function project_form_cancel_button_cb */


void project_form_accept_button_cb(FL_OBJECT *ob, long data)
{
char temp[TEMP_SIZE];
char *ptr;

if(project_form_modified_flag)
	{
	project_form_modified_flag = 0;
	}

fl_hide_form(fdui -> project_form);

if(fontsizes_modified_flag)
	{
	save_fontsizes();
	fontsizes_modified_flag = 0;
	}

if(new_project_flag)
	{
	ptr = (char *) fl_get_input(fdui -> project_form_input_field);
	if(! ptr) return;

	/* selected_project set by load projects */
	sprintf(temp, "%s", ptr);
	select_project(temp);

	/* this will fill in the fields in the setup form */
	load_projects();
	
	new_project_flag = 0;
	}

project_form_shown_flag = 0;
}/* end function project_form_accept_button_cb */


