/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "xste.h"

extern FD_xste *fdui;
extern FD_xste *fd_main_form;


int spellcheck_input_field()
{
int c;
FILE *pptr;
FILE *fptr;
struct stat *statptr;
char temp[4096];
int length;
char *ptr;
char *tptr;

if(debug_flag)
	{
	fprintf(stdout, "spellcheck_input_field(): arg none\n");
	}

/* get text from input field */
ptr = (char *)fl_get_input(fdui -> main_form_text_input_field);
if(! ptr) return 0;

/* write to temp file */
sprintf(temp, "echo %s > %s/tmp", ptr, home_dir);
pptr = popen(temp, "r");
pclose(pptr);

/* run ispell from an xterm on temp file */
sprintf(temp, "%s %s/tmp",spellcheck_command, home_dir);
pptr = popen(temp, "r");
pclose(pptr);

/* open the temp file for read */
sprintf(temp, "%s/tmp", home_dir);
fptr = fopen(temp, "r");
if(! fptr)
	{
	fl_show_alert("Could not open file", temp, "for read >spellcheck<", 1);
	return 0;
	}

/* get length of file */
/* create space for total */
statptr = (struct stat*) malloc(sizeof(struct stat) );
if(! statptr) return 0;

fstat(fileno(fptr), statptr);
length = statptr -> st_size;

free(statptr);

/* read in the file */
ptr = malloc(length + 1);
tptr = ptr;
while(1)
	{
	errno = 0;
	while(1)/* error re read */
		{
		c = getc(fptr);
		if(! ferror(fptr) ) break;
		perror(\
		"main_form_add_button_cb(): read failed ");
		}/* end while error re read */	

	if(feof(fptr) )
		{
		/* mark end of string */
		*tptr = 0;
		fclose(fptr);

		break;
		}

	*tptr = c;
	tptr++;	
	} /* end while all chars in file */

/* set the new corected text in input field */
fl_set_input(fdui -> main_form_text_input_field, ptr);

return 1;
}/* end function spellcheck_input_field */


int spellcheck_input_field_on_form()
{
/* this will mark the wrongly spelled words in the input field itself */
char *ptr;
char temp[4096];

if(debug_flag)
	{
	fprintf(stdout, "spellcheck_input_field_on_form(): arg none\n");
	}


ptr = (char *)fl_get_input(fdui -> main_form_text_input_field);
if(! ptr) return 0;

sprintf(temp, "@C1hello");


fl_set_input(fdui -> main_form_text_input_field, temp);

return 1;
}/* end function spellcheck_input_field_on_form */


int edit_frame_list()
{
FILE *pptr;
char temp[4096];
int line;

if(debug_flag)
	{
	fprintf(stdout, "spellcheck_all(): arg none\n");
	}

/* run editor joe from an xterm on data_file_name */
sprintf(temp,\
"%s %s/%s/%s/%s",\
editor_command, home_dir, selected_data_directory, selected_project,\
data_file_name);
pptr = popen(temp, "r");
pclose(pptr);

/* reload the frame list */
if(! load_frames() )
	{
	/* 
	error here, but if not exit then user can fix using 'edit frame list'.
	*/

	}

show_frames(SHOW_SAME_POSITION);

frame_to_line(selected_start_frame, &line);
fl_select_browser_line(fdui -> main_form_browser, line);

return 1;
} /* end function edit_frame_list */


