/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xste.h"

FD_xste *fdui;


static int atclose(FL_FORM * form, void *ev)
{
fl_trigger_object(form -> u_vdata);

return FL_IGNORE;
}


int show_subtitle_color_selector_form(int color)
{
FL_OBJECT *ob;
int index;

if(debug_flag)
	{
	printf("show_subtitle_color_selector_form(): arg color=%d\n", color);
	}

if(subtitle_color_selector_form_shown_flag) return 1;

subtitle_color_selector_form_shown_flag = 1;

subtitle_color_selector_form_set_all_color_buttons();

fdui -> subtitle_color_selector_form -> u_vdata = fdui -> subtitle_color_selector_form_cancel_button;

fl_set_form_atclose(fdui -> subtitle_color_selector_form, atclose, 0);
 
fl_deactivate_all_forms();

fl_show_form(fdui -> subtitle_color_selector_form, FL_PLACE_CENTER, FL_TRANSIENT,\
	"xste: subtitle color selector");

while(1)
	{
	ob = fl_do_only_forms();

	if(ob == fdui -> subtitle_color_selector_form_cancel_button)
		{
		index = color;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color0_button)
		{
		index = 0;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color1_button)
		{
		index = 1;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color2_button)
		{
		index = 2;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color3_button)
		{
		index = 3;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color4_button)
		{
		index = 4;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color5_button)
		{
		index = 5;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color6_button)
		{
		index = 6;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color7_button)
		{
		index = 7;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color8_button)
		{
		index = 8;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color9_button)
		{
		index = 9;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color10_button)
		{
		index = 10;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color11_button)
		{
		index = 11;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color12_button)
		{
		index = 12;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color13_button)
		{
		index = 13;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color14_button)
		{
		index = 14;
		break;
		}

	if(ob == fdui -> subtitle_color_selector_form_color15_button)
		{
		index = 15;
		break;
		}

	} /* end while all objects on form */


fl_hide_form(fdui -> subtitle_color_selector_form);

fl_activate_all_forms();

if(debug_flag)
	{
	fprintf(stdout, "show_subtitle_color_selector_form() returning index=%d\n", index);
	}

subtitle_color_selector_form_shown_flag = 0;

return index;
} /* end function show_subtitle_font_form */


int subtitle_color_selector_form_set_color_button(int button)
{
FL_OBJECT *obj = NULL;

if(debug_flag)
	{
	fprintf(stdout, "subtitle_color_selector_form_set_color_button(): arg button=%d\n", button);
	}

switch(button)
	{	
	case 0:
		obj = fdui -> subtitle_color_selector_form_color0_button;
		break;
	case 1:
		obj = fdui -> subtitle_color_selector_form_color1_button;
		break;
	case 2:
		obj = fdui -> subtitle_color_selector_form_color2_button;
		break;
	case 3:
		obj = fdui -> subtitle_color_selector_form_color3_button;
		break;
	case 4:
		obj = fdui -> subtitle_color_selector_form_color4_button;
		break;
	case 5:
		obj = fdui -> subtitle_color_selector_form_color5_button;
		break;
	case 6:
		obj = fdui -> subtitle_color_selector_form_color6_button;
		break;
	case 7:
		obj = fdui -> subtitle_color_selector_form_color7_button;
		break;
	case 8:
		obj = fdui -> subtitle_color_selector_form_color8_button;
		break;
	case 9:
		obj = fdui -> subtitle_color_selector_form_color9_button;
		break;
	case 10:
		obj = fdui -> subtitle_color_selector_form_color10_button;
		break;
	case 11:
		obj = fdui -> subtitle_color_selector_form_color11_button;
		break;
	case 12:
		obj = fdui -> subtitle_color_selector_form_color12_button;
		break;
	case 13:
		obj = fdui -> subtitle_color_selector_form_color13_button;
		break;
	case 14:
		obj = fdui -> subtitle_color_selector_form_color14_button;
		break;
	case 15:
		obj = fdui -> subtitle_color_selector_form_color15_button;
		break;
	} /* end switch button */

if(! obj)
	{
	fprintf(stderr, "subtitle_color_selector_form_set_color_button(): unknown button\n");

	return 0;
	}

fl_set_object_color(obj, FL_FREE_COL1 + button, FL_FREE_COL1 + button);

fl_redraw_object(obj);

return 1;
} /* end function subtitle_color_selector_form_set_color_button */


int subtitle_color_selector_form_set_all_color_buttons()
{
int i;

if(debug_flag)
	{
	fprintf(stdout, "subtitle_color_selector_form_set_all_color_buttons(): arg none\n");
	}

for(i = 0; i < 16; i++)
	{
	fl_mapcolor(FL_FREE_COL1 + i, xste_rgb_palette[i][0], xste_rgb_palette[i][1], xste_rgb_palette[i][2]);

	subtitle_color_selector_form_set_color_button(i);

	} /* end for al buttons */

return 1;
} /* end function subtitle_color_selector_form_set_all_color_buttons */


