#include "xste.h"


int load_suti_file(char *pathfilename)
{
int a;
char temp[READSIZE];
char temp2[READSIZE];
char temp3[80];
int start_frame, end_frame, previous_start_frame;
unsigned long start_sample, end_sample, previous_start_sample;
char text[READSIZE];
int text_hold_flag;
int line;
FILE *fptr;
char *ptr;

if(debug_flag)
	{
	fprintf(stdout, "load_suti() arg pathfilename=%s\n", pathfilename);
	}
	
if(! pathfilename) return 0;

fptr = fopen(pathfilename, "r");
if(! fptr)
	{
	fl_show_alert("could not open file", pathfilename, "for read", 1);

	if(debug_flag)
		{
		fprintf(stdout, "could not load file %s\n", pathfilename);
		}
	return 0;
	} 

delete_all_frames();

start_frame = 0; // -Wall
end_frame = 0; // -Wall

/* for all lines in file */
previous_start_sample = -1;
line = 0;
previous_start_frame = -1;
while(1)
	{
	a = readline(fptr, temp);
	if(a == EOF) break;

	a = sscanf(temp, "%s %s", temp3, temp2);
	if(a) start_frame = atoi(temp3);

	ptr = strstr(temp, temp2);
	if(! ptr)
		{
		text[0] = 0;
		}
	else
		{
		strcpy(text, ptr);	
		}

	if(debug_flag)
		{
		printf("load_suti_file(): a=%d line=%d start_frame=%d temp=%s\n",\
		a, line, start_frame, temp);
		}

	/* increment line counter for error reporting */
	line ++;

	/* 160 ms per frame in suti, 40 ms per frame */
	start_frame *= 4;
	end_frame *= 4;

	/* 
	now we know the end frame of the previous entry, it is this start frame.
	look the entry up and modify that end_frame
	*/
	/* test if the start_frame8 is lower then in the previous line */
	if( start_frame <= previous_start_frame)
		{
		sprintf(temp2,\
		"line %d start_frame=%d", line - 2, previous_start_frame / 4);
		sprintf(temp3,\
		"line %d start_frame=%d", line , start_frame / 4); 

		fl_show_alert(\
			"suti file: CONSISTENCY ERROR FIX IT", temp2, temp3, 1);

		/*
		load the file anyways, allow user to correct with the
		'edit frame list button'
		*/
		} /* end consistency check */

	/* modify the end_frame of the previous entry */
	/* first entry has no previous */
	if(start_frame != 0)
		{		
		if(! set_end_frame(previous_start_frame, start_frame) )
			{
			sprintf(temp, "could not set end_frame=%d for frame=%d",\
			start_frame, previous_start_frame);
			fl_show_alert("load_suti_file():", temp, "", 0);
			}
		}

	/* remember start_frame */
	previous_start_frame = start_frame;

	start_sample = 0;
	end_sample = 0;
	text_hold_flag = 0;
	
	/* add the frame */
	sprintf(temp, "%d", start_frame);
	if(! add_frame(\
	text,
	start_frame, end_frame,\
	text_hold_flag) )
		{
		sprintf(temp, "line %d could not add frame", line);
		fl_show_alert("load suti file:", temp, "aborting", 0);

		return 0;
		}

	}/* end while all lines in file */

return 1;
}/* end function load_suti_file */


int write_suti_list()
{
struct frame *pa;
struct frame *pnext;
FILE *fptr;
char temp[4096];
int next_frame_start;
char command_part[TEXT_ARRAY_SIZE];
char text_part[TEXT_ARRAY_SIZE];

if(debug_flag)
	{
	printf("write_suti_list(): arg none\n");
	}

draw_mode = DRAW_MODE_BW;

sprintf(temp, "%s/%s/%s/new-timed.txt",\
home_dir, selected_data_directory, selected_project);
fptr = fopen(temp, "w");
if(! fptr)
	{
	fl_show_alert("write_suti_list", "Could not open for write", temp, 1);

	return 0;
	}

for(pa = frametab[0]; pa != 0; pa = pa -> nxtentr)
	{
	/* skip any comamnd lines */
//	if(pa -> text[0] == '*') continue;

	/* split of any command in the form of '[female] */
	if(! extract_command(pa -> text, text_part, command_part) ) return 0;

	fprintf(fptr, "%d %s\n", atoi(pa -> name) / 4, text_part);

	/* the title must disappear after the specified time */

	/* first get pointer to next structure entry */ 
	if(pa -> nxtentr) 
		{
		pnext = pa -> nxtentr;	
		
		/* get the start of the next frame */ 
		next_frame_start = atoi(pnext -> name);

		/* test if the current frame ends before the start of the next */
		if(pa -> end_frame < next_frame_start)
			{
			/*
			Insert an empty line with one space here to make the current
			text disappear (suti processes this).
			*/
			/* 
			Only make text go away if it was not a text go away line !
			set by the user.
			*/
			if(strlen(text_part) != 0)
				{
				fprintf(fptr, "%d \n", pa -> end_frame / 4);
				}
			} /* end if frame ends before next one starts */ 
		} /* end if not last entry */	

	else /* last entry */
		{
		/*
		the last entry text should also be removed at the specified time.
		*/
		/* 
		Only make text go away if it was not a text go away line !
		set by the user.
		*/
		if(strlen(text_part) != 0)
			{
			fprintf(fptr, "%d \n", pa -> end_frame / 4);
			}
		}
	} /* end for all frames */

/* close the file */
fclose(fptr);

return 1;
}/* end function write_suti_list */


