/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "xste.h"

extern FD_xste *fdui;
extern FD_xste *fd_main_form;


int take_preview_snapshot(int frame)
{
int r, g, b, x, y;
unsigned char *ucptrs;
FILE *pppm_file;
char temp[4096];
char temp2[4096];

if(debug_flag)
	{
	fprintf(stdout, "take_preview_snapshot(): frame=%d\n", frame);
	}

/* get X11 buffer */
ucptrs = (unsigned char *)getbuf();
if(! ucptrs)
	{
	fl_show_alert("No picture data", "enable PREVIEW and VIDEO", "no snapshot taken", 0);

	return 0;
	}

/* make filename */
sprintf(temp, "/video/vie/%s/%d.ppm", selected_project, frame);

/* test if exists */
pppm_file = fopen(temp, "r");
if(pppm_file)
	{
	fclose(pppm_file);

	sprintf(temp2, "File %s exists, overwrite?", temp);	
	if(! fl_show_question(temp2, 0) ) return 0;
	}

pppm_file = fopen(temp, "w");
if(! pppm_file)
	{
	fl_show_alert("Could not open this file for write", temp, "no shapshot taken", 0);

	return 0;
	}

/* write the ppm header */
fprintf(pppm_file, "P6\n%i %i\n255\n", h_size, v_size);

/* need vertical flip, but not horizontal flip */
if(color_depth == 32)
	{
	for(y = 0; y < v_size; y++)
		{
		for(x = 0; x < h_size; x++)
			{
			b = *ucptrs++;
			g = *ucptrs++;
			r = *ucptrs++;

			fprintf(pppm_file, "%c%c%c", r, g, b);

			ucptrs++; /* nothing in byte 4 */
			}
		} /* end for y (all lines) */
	} /* end if color_depth 32 */
else if(color_depth == 24) // NOT TESTED!!!!!!!!
	{
	for(y = 0; y < v_size; y++)
		{
		for(x = 0; x < h_size; x++)
			{
			b = *ucptrs++;
			g = *ucptrs++;
			r = *ucptrs++;

			fprintf(pppm_file, "%c%c%c", r, g, b);
			}
		} /* end for y (all lines) */
	} /* end if color_depth 24 */

fclose(pppm_file);

return 1;
} /* end function take_preview_snapshot */


