#include "xste.h"


struct temp_frame *lookup_temp_frame(char *name)
{
struct temp_frame *pa;

for(pa = temp_frametab[0]; pa != 0; pa = pa -> nxtentr)
	{
	if(strcmp(pa -> name, name) == 0) return(pa);
	}
return 0; /*not found*/
}/* end function lookup_temp_frame */


struct temp_frame *install_temp_frame_at_end_of_list(char *name)
{
struct temp_frame *plast, *pnew;

if(debug_flag)
	{
	fprintf(stdout,\
	"install_temp_frame_at_end_off_list(): arg name=%s\n", name);
	}

pnew = lookup_temp_frame(name);
if(pnew) return(pnew);/* already there */

/* create new structure */
pnew = (struct temp_frame *) calloc(1, sizeof(*pnew) );
if(! pnew) return 0;
pnew -> name = strsave(name);
if(! pnew -> name) return 0;

/* get previous structure */
plast = temp_frametab[1]; /* end list */

/* set new structure pointers */
pnew -> nxtentr = 0; /* new points top zero (is end) */
pnew -> prventr = plast; /* point to previous entry, or 0 if first entry */

/* set previous structure pointers */
if( !temp_frametab[0] ) temp_frametab[0] = pnew; /* first element in list */
else plast -> nxtentr = pnew;

/* set array end pointer */
temp_frametab[1] = pnew;

return(pnew);/* pointer to new structure */
}/* end function install_temp_frame */


int delete_temp_frame(int temp_framenr)/* delete entry from double linked list */
{
struct temp_frame *pa, *pprev, *pdel, *pnext;
char name[80];

if(debug_flag)
	{
	fprintf(stdout, "delete_temp_frame(): arg temp_framenr=%d\n", temp_framenr);
	}

sprintf(name, "%d", temp_framenr);
pa = temp_frametab[0];
while(1)
	{
	/* if end list, return not found */
	if(! pa) return 0;

	/* test for match in name */
	if(strcmp(name, pa -> name) != 0) /* no match */
		{
		/* point to next element in list */
		pa = pa -> nxtentr;

		/* loop for next element in list */
		continue;
		}

	/* we now know which struture to delete */
	pdel = pa;

	/* get previous and next structure */
	pnext = pa -> nxtentr;
	pprev = pa -> prventr;

	/* set pointers for previous structure */
	/* if first one, modify temp_frametab[0] */
	if(pprev == 0) temp_frametab[0] = pnext;
	else pprev -> nxtentr = pnext;

	/* set pointers for next structure */
	/* if last one, modify temp_frametab[1] */
	if(pnext == 0) temp_frametab[1] = pprev;
	else pnext -> prventr = pprev;
	
	/* delete structure */	
	free(pdel -> name);
	free(pdel -> text);
	free(pdel -> fontname);
	free(pdel); /* free structure */

	/* return OK deleted */
	return 1;
	}/* end for all structures */
}/* end function delete_temp_frame */


int delete_all_temp_frames()/* delete all entries from table */
{
struct temp_frame *pa;

if(debug_flag)
	{
	fprintf(stdout, "delete_all_temp_frames() arg none\n");
	}

while(1)
	{	
	pa = temp_frametab[0];
	if(! pa) break;
	temp_frametab[0] = pa -> nxtentr;

	free(pa -> name);
	free(pa -> text);
	free(pa -> fontname);
	free(pa);/* free structure */
	}/* end while all structures */

temp_frametab[1] = 0;
return 1;
}/* end function delete_all_temp_frames */




