#include "xste.h"


int write_vplayer_list()
{
/*
purpose of this routine is to also write a vplayer subtitle format file,
so subtitles can be read by Linux mplayer.
vplayer ?? uses a time oriented format, see
/root/compile/dvb/mplayer/MPlayer-0.50/subreader.c
*/
struct frame *pa;
struct frame *pnext, *ptemp;
FILE *fptr;
char temp[4096];
int next_frame_start;
int start_hour, start_minute, start_second;
int end_hour, end_minute, end_second;
int text_end_frame;
double audio_samples_per_frame;
long lthousands;
double dstart_second, dend_second;
char command_part[TEXT_ARRAY_SIZE];
char text_part[TEXT_ARRAY_SIZE];

if(debug_flag)
	{
	printf("write_vplayer_list(): arg none\n");
	}

draw_mode = DRAW_MODE_BW;

/* 40 ms per frame (of 25 Hz) */
audio_samples_per_frame = audio_sample_speed / dmilli_seconds_per_frame;

/* had to imagine some extention name */
sprintf(temp, "%s/%s/%s/%s.vplayer",\
home_dir, selected_data_directory, selected_project, selected_project);
fptr = fopen(temp, "w");
if(! fptr)
	{
	fl_show_alert("write_vplayer_list", "Could not open for write", temp, 1);

	return 0;
	}

for(pa = frametab[0]; pa != 0; pa = pa -> nxtentr)
	{
	text_end_frame = pa -> end_frame;

	/* get pointer to next structure entry */ 
	if(pa -> nxtentr) 
		{
		pnext = pa -> nxtentr;	
		
		/* find next line that is not a '*' comand line */
		while(pnext)
			{
			if(pnext -> text[0] != '*') break;

			if(pnext -> nxtentr)
				{	
				ptemp = pnext -> nxtentr;

				pnext = ptemp;
				}	
			} /* end while looking for non '*' entry */ 

		if(pnext)
			{
			/* get the start of the next frame */ 
			next_frame_start = atoi(pnext -> name);
		
			/* test if the current frame ends before the start of the next */
			if(pa -> end_frame > next_frame_start)
				{
				text_end_frame = next_frame_start;
				} /* end if frame ends before next one starts */ 
			}

		} /* end if not last entry */	
	
	/* we have this data at our disposal */ 
	//	char *name;/* this is the start frame / 8 */
	//	char *text;
	//	int end_frame; /* this is the end frame / 8 */
	//	unsigned long start_sample;
	//	unsigned long end_sample;
	//	unsigned long picture_number;

	/*
	from mplayer:
	current->start = a1*360000+a2*6000+a3*100;
	current->end   = b1*360000+b2*6000+b3*100;
	*/

	/* calculate start_time */
	lthousands = atoi(pa -> name) * dmilli_seconds_per_frame;
	start_hour = lthousands / 3600000;
	lthousands -= start_hour * 3600000; 
	start_minute = lthousands / 60000;
	lthousands -= start_minute * 60000;
	dstart_second = lthousands / 1000.0;
	start_second = (int)dstart_second;

	/* calculate end_time */
	lthousands = text_end_frame * dmilli_seconds_per_frame;
	end_hour = lthousands / 3600000;
	lthousands -= end_hour * 3600000; 
	end_minute = lthousands / 60000;
	lthousands -= end_minute * 60000;
	dend_second = lthousands / 1000.0;
	end_second = (int)dend_second;

	/* do not print any lines starting with '*' */
	if(pa -> text[0] == '*') continue;

	/* split of any command in the form of '[female] */
	if(! extract_command(pa -> text, text_part, command_part) ) return 0;

	/* write start time plus text */
	fprintf(fptr, "%02d:%02d:%02d:%s\n",\
	start_hour, start_minute, start_second, text_part);

	/* write end time */
	fprintf(fptr, "%02d:%02d:%02d:\n",\
	end_hour, end_minute, end_second);

	} /* end for all frames */

/* close the file */
fclose(fptr);

return 1;
}/* end function write_vplayer_list */

