/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
~*/


#ifndef FD_xste_h_
#define FD_xste_h_

#include <forms.h>

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <sys/time.h>
#include <signal.h>
#include <setjmp.h>
#include <pwd.h>
#include <math.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <errno.h>
#include <fcntl.h>
#include <linux/soundcard.h>

#include <pthread.h>
#include <sys/poll.h>
#include <stdint.h>
#include <locale.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/ioctl.h>

#include <libmpeg3/libmpeg3.h>

#include "load_font.h"
#include "frame_list.h"
#include "temp_frame_list.h"
#include "wave_header.h"
#include "fonts.h"
#include "ebu_gsi.h"
#include "subtitle_fontname_list.h"
#include "animation_template.h"

/* for YUV to RGB */                        
#define LIMIT(x) ((((x)>0xffffff)?0xff0000:(((x)<=0xffff)?0:(x)&0xff0000))>>16)

typedef struct {
	FL_FORM *main_form;
	FL_FORM *project_form;	
	FL_FORM *export_form;
	FL_FORM *fonts_form;
	FL_FORM *special_characters_form;
	FL_FORM *subtitle_font_form;
	FL_FORM *ebu_general_subtitle_information_form;
	FL_FORM *text_properties_form;
	FL_FORM *global_subtitle_palette_form;
	FL_FORM *subtitle_color_selector_form;
	FL_FORM *animation_template_form;

	FL_OBJECT *main_form_window_menu;
	FL_OBJECT *main_form_outfield;
	FL_OBJECT *main_form_title;
	FL_OBJECT *main_form_h_size_input_field;
	FL_OBJECT *main_form_h_margin_input_field;
	FL_OBJECT *main_form_h_factor_input_field;
	FL_OBJECT *main_form_v_size_input_field;
	FL_OBJECT *main_form_v_margin_input_field;
	FL_OBJECT *main_form_v_factor_input_field;
	FL_OBJECT *main_form_preview_button;
	FL_OBJECT *main_form_video_in_preview_button;
	FL_OBJECT *main_form_browser;
	FL_OBJECT *main_form_search_input_field;
	FL_OBJECT *main_form_audio_mode_button;
	FL_OBJECT *main_form_search_case_button;
	FL_OBJECT *main_form_search_button;
	FL_OBJECT *main_form_video_display_button;
	FL_OBJECT *main_form_next_red_button;
	FL_OBJECT *main_form_volume_slider;
	FL_OBJECT *main_form_erase_all_empty_lines_button;
	FL_OBJECT *main_form_edit_frame_list_button;
	FL_OBJECT *main_form_spellcheck_input_button;
	FL_OBJECT *main_form_delete_button;
	FL_OBJECT *main_form_clear_button;
	FL_OBJECT *main_form_add_button;
	FL_OBJECT *main_form_text_input_field;
	FL_OBJECT *main_form_frame_input_field;
	FL_OBJECT *main_form_frame_now_button;
	FL_OBJECT *main_form_current_frame_input_field;
	FL_OBJECT *main_form_text_hold_button;
	FL_OBJECT *main_form_text_duration_input_field;
	FL_OBJECT *main_form_frames_per_second_input_field;
	FL_OBJECT *main_form_hold_text_properties_button;
	FL_OBJECT *main_form_set_PAL_fps_button;
	FL_OBJECT *main_form_set_NTSC_fps_button;
	FL_OBJECT *main_form_play_button;
	FL_OBJECT *main_form_auto_switch;
	FL_OBJECT *main_form_synthesize_switch;
	FL_OBJECT *main_form_output_switch;
	FL_OBJECT *main_form_move_from_switch;
	FL_OBJECT *main_form_play_part_button_frwd;
	FL_OBJECT *main_form_play_part_button_rwd;
	FL_OBJECT *main_form_play_part_button_fwd;
	FL_OBJECT *main_form_play_part_button_ffwd;
	FL_OBJECT *main_form_mem1_button;
	FL_OBJECT *main_form_rcl_button;
	FL_OBJECT *main_form_snap_button;
	FL_OBJECT *main_form_local_clock;
	FL_OBJECT *main_form_file_menu;
	FL_OBJECT *main_form_fontsize_up_button;
	FL_OBJECT *main_form_fontsize_down_button;
	FL_OBJECT *main_form_exit_switch;
	FL_OBJECT *main_form_align_start_button;
	FL_OBJECT *main_form_align_end_button;
	FL_OBJECT *main_form_preview_snapshot_button;
	FL_OBJECT *main_form_show_time_overlap_button;
	
	FL_OBJECT *project_form_title;
	FL_OBJECT *project_form_browser;
	FL_OBJECT *project_form_input_field;
	FL_OBJECT *project_form_delete_button;
	FL_OBJECT *project_form_add_button;
	FL_OBJECT *project_form_fontsize_up_button;
	FL_OBJECT *project_form_fontsize_down_button;
	FL_OBJECT *project_form_cancel_button;
	FL_OBJECT *project_form_accept_button;

	FL_OBJECT *export_form_title;
	FL_OBJECT *export_form_output_format_selection_group;
	FL_OBJECT *export_form_ppml_yuv_output_options_box;
	FL_OBJECT *export_form_ppml_output_options_box;
	FL_OBJECT *export_form_microdvdplayer_output_options_box;
	FL_OBJECT *export_form_ebu_stl_output_options_box;
	FL_OBJECT *export_form_select_text;
	FL_OBJECT *export_form_enable_ppml_for_subtitler_yuv_output_button;
	FL_OBJECT *export_form_enable_ppml_output_button;
	FL_OBJECT *export_form_enable_suti_output_button;
	FL_OBJECT *export_form_enable_ssa_output_button;
	FL_OBJECT *export_form_enable_vplayer_output_button;
	FL_OBJECT *export_form_enable_submux_output_button;
	FL_OBJECT *export_form_enable_submux_dvd_output_button;
	FL_OBJECT *export_form_enable_microdvdplayer_output_button;
	FL_OBJECT *export_form_use_animation_templates_button;
	FL_OBJECT *export_form_ppml_use_dvd_colors_button;
	FL_OBJECT *export_form_ppml_enable_monitor_button;
	FL_OBJECT *export_form_let_microdvdplayer_format_button;
	FL_OBJECT *export_form_enable_iauthor_output_button;
	FL_OBJECT *export_form_enable_ebu_stl_output_button;
	FL_OBJECT *export_form_ebu_general_subtitle_information_button;
	FL_OBJECT *export_form_enable_srt_output_button;
	FL_OBJECT *export_form_output_format_select_box;
	FL_OBJECT *export_form_enable_chapter_list_output_button;
	FL_OBJECT *export_form_cancel_button;
	FL_OBJECT *export_form_accept_button;
	FL_OBJECT *export_form_fontsize_up_button;
	FL_OBJECT *export_form_fontsize_down_button;

	FL_OBJECT *fonts_form_title;
	FL_OBJECT *fonts_form_font_button_group;
	FL_OBJECT *fonts_form_global_fonts_button;
	FL_OBJECT *fonts_form_default_fonts_button;
	FL_OBJECT *fonts_form_article_fonts_button;
	FL_OBJECT *fonts_form_browser;
	FL_OBJECT *fonts_form_fontsize_up_button;
	FL_OBJECT *fonts_form_fontsize_down_button;
	FL_OBJECT *fonts_form_accept_button;

	FL_OBJECT *special_characters_form_form_title;
	FL_OBJECT *special_characters_form_input; /* only used as output */
	FL_OBJECT *special_characters_form_clear_button;
	FL_OBJECT *special_characters_form_cancel_button;
	FL_OBJECT *special_characters_form_accept_button;
	FL_OBJECT *special_characters_form_fontsize_up_button;
	FL_OBJECT *special_characters_form_fontsize_down_button;

	FL_OBJECT *subtitle_font_form_title;
	FL_OBJECT *subtitle_font_form_fontname_button;
	FL_OBJECT *subtitle_font_form_fontname_output_field;
	FL_OBJECT *subtitle_font_form_fontname_output_field_text;
	FL_OBJECT *subtitle_font_form_dvd_default_button;
	FL_OBJECT *subtitle_font_form_cvd_default_button;
	FL_OBJECT *subtitle_font_form_svcd_default_button;
	FL_OBJECT *subtitle_font_form_character_point_size_input_field;
	FL_OBJECT *subtitle_font_form_character_style_input_field;
	FL_OBJECT *subtitle_font_form_outline_thickness_input_field;
	FL_OBJECT *subtitle_font_form_blur_radius_input_field;
	FL_OBJECT *subtitle_font_form_espace_input_field;
	FL_OBJECT *subtitle_font_form_vespace_input_field;
	FL_OBJECT *subtitle_font_form_center_text_button;
	FL_OBJECT *subtitle_font_form_no_kerning_button;
	FL_OBJECT *subtitle_font_form_anti_alias_button;
	FL_OBJECT *subtitle_font_form_color0_button;
	FL_OBJECT *subtitle_font_form_color1_button;
	FL_OBJECT *subtitle_font_form_color2_button;
	FL_OBJECT *subtitle_font_form_color3_button;
	FL_OBJECT *subtitle_font_form_contrast0_input_field; 
	FL_OBJECT *subtitle_font_form_contrast1_input_field; 
	FL_OBJECT *subtitle_font_form_contrast2_input_field; 
	FL_OBJECT *subtitle_font_form_contrast3_input_field; 
	FL_OBJECT *subtitle_font_form_subtitle_fontsize_up_button;
	FL_OBJECT *subtitle_font_form_subtitle_fontsize_down_button;
	FL_OBJECT *subtitle_font_form_cancel_button;
	FL_OBJECT *subtitle_font_form_accept_button;

	FL_OBJECT *ebu_general_subtitle_information_form_form_title;
	FL_OBJECT *ebu_general_subtitle_information_form_standard_code_buttons_group;
	FL_OBJECT *ebu_general_subtitle_information_form_code_page_number_input;
	FL_OBJECT *ebu_general_subtitle_information_form_disk_format_code_input;
	FL_OBJECT *ebu_general_subtitle_information_form_display_standard_code_open_button;
	FL_OBJECT *ebu_general_subtitle_information_form_display_standard_code_teletext1_button;
	FL_OBJECT *ebu_general_subtitle_information_form_display_standard_code_teletext2_button;
	FL_OBJECT *ebu_general_subtitle_information_form_character_code_input;
	FL_OBJECT *ebu_general_subtitle_information_form_language_code_input;
	FL_OBJECT *ebu_general_subtitle_information_form_original_program_title_input;
	FL_OBJECT *ebu_general_subtitle_information_form_original_episode_title_input;
	FL_OBJECT *ebu_general_subtitle_information_form_translated_program_title_input;
	FL_OBJECT *ebu_general_subtitle_information_form_translated_episode_title_input;
	FL_OBJECT *ebu_general_subtitle_information_form_original_translators_name_input;
	FL_OBJECT *ebu_general_subtitle_information_form_translators_contact_details_input;
	FL_OBJECT *ebu_general_subtitle_information_form_subtitle_list_reference_code_input;
	FL_OBJECT *ebu_general_subtitle_information_form_creation_date_input;
	FL_OBJECT *ebu_general_subtitle_information_form_revision_date_input;
	FL_OBJECT *ebu_general_subtitle_information_form_revision_number_input;
	FL_OBJECT *ebu_general_subtitle_information_form_tti_blocks_input;
	FL_OBJECT *ebu_general_subtitle_information_form_number_of_subtitles_input;
	FL_OBJECT *ebu_general_subtitle_information_form_subtitle_groups_input;
	FL_OBJECT *ebu_general_subtitle_information_form_max_columns_input;
	FL_OBJECT *ebu_general_subtitle_information_form_max_rows_input;
	FL_OBJECT *ebu_general_subtitle_information_form_timecode_valid_button;
	FL_OBJECT *ebu_general_subtitle_information_form_timecode_start_of_program_input;
	FL_OBJECT *ebu_general_subtitle_information_form_timecode_first_cue_in_input;
	FL_OBJECT *ebu_general_subtitle_information_form_number_of_disks_input;
	FL_OBJECT *ebu_general_subtitle_information_form_disk_sequence_number_input;
	FL_OBJECT *ebu_general_subtitle_information_form_country_of_origin_input;
	FL_OBJECT *ebu_general_subtitle_information_form_publisher_input;
	FL_OBJECT *ebu_general_subtitle_information_form_editors_name_input;
	FL_OBJECT *ebu_general_subtitle_information_form_editors_contact_details_input;
	FL_OBJECT *ebu_general_subtitle_information_form_defaults_dutch_button;
	FL_OBJECT *ebu_general_subtitle_information_form_cancel_button;
	FL_OBJECT *ebu_general_subtitle_information_form_accept_button;
	FL_OBJECT *ebu_general_subtitle_information_form_fontsize_down_button;
	FL_OBJECT *ebu_general_subtitle_information_form_fontsize_up_button;

	FL_OBJECT *text_properties_form_form_title;
	FL_OBJECT *text_properties_form_fontname_button;
	FL_OBJECT *text_properties_form_fontname_output_field;
	FL_OBJECT *text_properties_form_fontname_output_field_text;
	FL_OBJECT *text_properties_form_fontsize_input_field;
	FL_OBJECT *text_properties_form_iso_extension_number_input_field;
	FL_OBJECT *text_properties_form_espace_input_field;
	FL_OBJECT *text_properties_form_vespace_input_field;
	FL_OBJECT *text_properties_form_dvd_default_button;
	FL_OBJECT *text_properties_form_outline_thickness_input_field;
	FL_OBJECT *text_properties_form_blur_radius_input_field;
	FL_OBJECT *text_properties_form_center_text_button;
	FL_OBJECT *text_properties_form_no_kerning_button;
	FL_OBJECT *text_properties_form_anti_alias_button;
	FL_OBJECT *text_properties_form_color0_button;
	FL_OBJECT *text_properties_form_color1_button;
	FL_OBJECT *text_properties_form_color2_button;
	FL_OBJECT *text_properties_form_color3_button;
	FL_OBJECT *text_properties_form_contrast0_input_field;
	FL_OBJECT *text_properties_form_contrast1_input_field;
	FL_OBJECT *text_properties_form_contrast2_input_field;
	FL_OBJECT *text_properties_form_contrast3_input_field;
	FL_OBJECT *text_properties_form_fontsize_up_button;
	FL_OBJECT *text_properties_form_fontsize_down_button;
	FL_OBJECT *text_properties_form_cancel_button;
	FL_OBJECT *text_properties_form_accept_button;

	FL_OBJECT *global_subtitle_palette_form_form_title;
	FL_OBJECT *global_subtitle_palette_form_color_buttons_group;
	FL_OBJECT *global_subtitle_palette_form_cancel_button;
	FL_OBJECT *global_subtitle_palette_form_accept_button;
	FL_OBJECT *global_subtitle_palette_form_fontsize_up_button;
	FL_OBJECT *global_subtitle_palette_form_ontsize_down_button;
	FL_OBJECT *global_subtitle_palette_form_color_slider_red;
	FL_OBJECT *global_subtitle_palette_form_color_slider_green;
	FL_OBJECT *global_subtitle_palette_form_color_slider_blue;
	FL_OBJECT *global_subtitle_palette_form_color0_button;
	FL_OBJECT *global_subtitle_palette_form_color1_button;
	FL_OBJECT *global_subtitle_palette_form_color2_button;
	FL_OBJECT *global_subtitle_palette_form_color3_button;
	FL_OBJECT *global_subtitle_palette_form_color4_button;
	FL_OBJECT *global_subtitle_palette_form_color5_button;
	FL_OBJECT *global_subtitle_palette_form_color6_button;
	FL_OBJECT *global_subtitle_palette_form_color7_button;
	FL_OBJECT *global_subtitle_palette_form_color8_button;
	FL_OBJECT *global_subtitle_palette_form_color9_button;
	FL_OBJECT *global_subtitle_palette_form_color10_button;
	FL_OBJECT *global_subtitle_palette_form_color11_button;
	FL_OBJECT *global_subtitle_palette_form_color12_button;
	FL_OBJECT *global_subtitle_palette_form_color13_button;
	FL_OBJECT *global_subtitle_palette_form_color14_button;
	FL_OBJECT *global_subtitle_palette_form_color15_button;
	FL_OBJECT *global_subtitle_palette_form_defaults_button;
	FL_OBJECT *global_subtitle_palette_form_color_circle_dial;
	FL_OBJECT *global_subtitle_palette_form_color_circle_input;

	FL_OBJECT *subtitle_color_selector_form_form_title;
	FL_OBJECT *subtitle_color_selector_form_color_buttons_group;
	FL_OBJECT *subtitle_color_selector_form_color0_button;
	FL_OBJECT *subtitle_color_selector_form_color1_button;
	FL_OBJECT *subtitle_color_selector_form_color2_button;
	FL_OBJECT *subtitle_color_selector_form_color3_button;
	FL_OBJECT *subtitle_color_selector_form_color4_button;
	FL_OBJECT *subtitle_color_selector_form_color5_button;
	FL_OBJECT *subtitle_color_selector_form_color6_button;
	FL_OBJECT *subtitle_color_selector_form_color7_button;
	FL_OBJECT *subtitle_color_selector_form_color8_button;
	FL_OBJECT *subtitle_color_selector_form_color9_button;
	FL_OBJECT *subtitle_color_selector_form_color10_button;
	FL_OBJECT *subtitle_color_selector_form_color11_button;
	FL_OBJECT *subtitle_color_selector_form_color12_button;
	FL_OBJECT *subtitle_color_selector_form_color13_button;
	FL_OBJECT *subtitle_color_selector_form_color14_button;
	FL_OBJECT *subtitle_color_selector_form_color15_button;
	FL_OBJECT *subtitle_color_selector_form_cancel_button;	

	FL_OBJECT *animation_template_form_form_title;
	FL_OBJECT *animation_template_form_browser;
	FL_OBJECT *animation_template_form_input_field;
	FL_OBJECT *animation_template_form_delete_button;
	FL_OBJECT *animation_template_form_add_button;
	FL_OBJECT *animation_template_form_fontname_button;
	FL_OBJECT *animation_template_form_fontname_output_field;
	FL_OBJECT *animation_template_form_fontname_output_field_text;
	FL_OBJECT *animation_template_form_default_button;
	FL_OBJECT *animation_template_form_character_point_size_input_field;
	FL_OBJECT *animation_template_form_character_style_input_field;
	FL_OBJECT *animation_template_form_outline_thickness_input_field;
	FL_OBJECT *animation_template_form_blur_radius_input_field;
	FL_OBJECT *animation_template_form_vespace_input_field;
	FL_OBJECT *animation_template_form_color_circle_dial;
	FL_OBJECT *animation_template_form_center_button;
	FL_OBJECT *animation_template_form_reformat_button;

	FL_OBJECT *animation_template_form_heading_dial;
	FL_OBJECT *animation_template_form_heading_degrees_output_field;
	FL_OBJECT *animation_template_form_dheading_slider;
	FL_OBJECT *animation_template_form_dheading_slider_reset_button;

	FL_OBJECT *animation_template_form_heading_or_x_y_select_button;

	FL_OBJECT *animation_template_form_xpos_slider;
	FL_OBJECT *animation_template_form_dxpos_slider;
	FL_OBJECT *animation_template_form_dxpos_slider_reset_button;

	FL_OBJECT *animation_template_form_ypos_slider;
	FL_OBJECT *animation_template_form_dypos_slider;
	FL_OBJECT *animation_template_form_dypos_slider_reset_button;

	FL_OBJECT *animation_template_form_speed_slider;
	FL_OBJECT *animation_template_form_dspeed_slider;
	FL_OBJECT *animation_template_form_dspeed_slider_reset_button;

	FL_OBJECT *animation_template_form_x_y_positioner;
	FL_OBJECT *animation_template_form_x_y_position_output_field;

	FL_OBJECT *animation_template_form_espace_slider;
	FL_OBJECT *animation_template_form_espace_slider_reset_button;
	FL_OBJECT *animation_template_form_despace_slider;
	FL_OBJECT *animation_template_form_despace_slider_reset_button;

	FL_OBJECT *animation_template_form_contrast_slider;
	FL_OBJECT *animation_template_form_dcontrast_slider;
	FL_OBJECT *animation_template_form_dcontrast_slider_reset_button;

	FL_OBJECT *animation_template_form_transparency_slider;
	FL_OBJECT *animation_template_form_dtransparency_slider;
	FL_OBJECT *animation_template_form_dtransparency_slider_reset_button;

	FL_OBJECT *animation_template_form_color_degrees_output_field;
	FL_OBJECT *animation_template_form_dcolor_slider;
	FL_OBJECT *animation_template_form_dcolor_slider_reset_button;

	FL_OBJECT *animation_template_form_saturation_slider;
	FL_OBJECT *animation_template_form_dsaturation_slider;
	FL_OBJECT *animation_template_form_dsaturation_slider_reset_button;

	FL_OBJECT *animation_template_form_zpos_slider;
	FL_OBJECT *animation_template_form_dzpos_slider;
	FL_OBJECT *animation_template_form_dzpos_slider_reset_button;

	FL_OBJECT *animation_template_form_fontsize_down_button;
	FL_OBJECT *animation_template_form_fontsize_up_button;
	FL_OBJECT *animation_template_form_cancel_button;
	FL_OBJECT *animation_template_form_accept_button;
	

} FD_xste;

extern FD_xste *create_form_main_form(void);
extern FD_xste *create_form_project_form(void);
extern FD_xste *create_form_export_form(void);
extern FD_xste *create_form_fonts_form(void);
extern FD_xste *create_form_special_characters_form(void);
extern FD_xste *create_form_subtitle_font_form(void);
extern FD_xste *create_form_ebu_general_subtitle_information_form(void);
extern FD_xste *create_form_text_properties_form(void);
extern FD_xste *create_form_global_subtitle_palette_form(void);
extern FD_xste *create_form_subtitle_color_selector_form(void);
extern FD_xste *create_form_animation_template_form(void);

#define READSIZE			65535
#define TEMP_SIZE			65535
/* this is set by the the length limit of a browser line in xforms */
#define TEXT_ARRAY_SIZE		1024

/* set some limits for this system */
#define MAX_H_PIXELS		2048
#define MAX_V_PIXELS		2048
#define MAX_SCREEN_LINES	200

/* for formatting subtitles */
#define SUBTITLE_H_FACTOR	.02
#define SUBTITLE_V_FACTOR	.042

/* for this specific default font */
#define EXTRA_CHAR_SPACE	1 //l followed by t overlap in this font
#define EXTRA_CHAR_VSPACE	0

/* for position browser display */
#define SHOW_TOP			0
#define SHOW_SAME_POSITION	1
#define SHOW_UNREAD_AT_TOP	2
#define SHOW_BOTTOM			3

/* for status in frame browser and formatting USE 1 2 4 8 */
#define NEW_ENTRY		0
#define NO_SPACE		1
#define TOO_LONG		2
#define TXT_HOLD		4
#define CENTER_TEXT 	8
#define DVD_ANTI_ALIAS	16
#define NO_KERNING		32
#define RLE_ERROR		64
#define TEST_BITMAP		128

/* for main form file menu */
#define PROJECTS							1
#define IMPORT_PPML_FILE					2
#define IMPORT_SUTI_FILE					3
#define IMPORT_SSA_FILE						4
#define IMPORT_NANDUB_FILE					5
#define IMPORT_SRT_FILE						6    
#define EXPORT_SETTINGS						7
#define ANIMATION_TEMPLATES					8
#define XSTE_FONTS							9
#define GLOBAL_SUBTITLE_PALETTE				10
#define DEFAULT_SUBTITLE_FONT_SETTINGS		11
#define FORCE_DEFAULT_TO_ALL_SUBTITLES		12
#define SPECIAL_CHARACTERS					13
#define EXIT								14

/* for video player */
#define VIDEO_OK				0
#define VIDEO_NO_OPEN			1
#define VIDEO_NO_XBUFFER		2
#define VIDEO_NO_JPG_DECODE		3
#define VIDEO_NO_STREAMS		4
#define VIDEO_NO_SIZE			5
#define VIDEO_NO_FILENAME		6
#define VIDEO_NO_VIDEO			7
#define VIDEO_FPS				8
#define VIDEO_SET_FRAME			9
#define VIDEO_SIZE_TOO_BIG		10
#define VIDEO_SIZE_ZERO			11
#define VIDEO_SIZE_DIFFERENT	12

/* for video + audio play duration in seconds when right mouse clicked in browser */
#define RIGHT_MOUSE_PLAY_SECONDS 10

/* for fonts selection buttons */
#define ARTICLE_FONTS	0
#define GLOBAL_FONTS	1
#define DEFAULT_FONTS	2

/* for draw_mode */
#define DRAW_MODE_BW			0
#define DRAW_MODE_BW_FAST		1
#define DRAW_MODE_COLOR			2
#define DRAW_MODE_OGT			3

/* for output_format */
#define OUTPUT_FORMAT_PPML_FOR_SUBTITLER_YUV	0
#define OUTPUT_FORMAT_PPML						1
#define OUTPUT_FORMAT_SUTI						2
#define OUTPUT_FORMAT_SSA						3
#define OUTPUT_FORMAT_VPLAYER					4
#define OUTPUT_FORMAT_SUBMUX					5
#define OUTPUT_FORMAT_SUBMUX_DVD				6
#define OUTPUT_FORMAT_MICRO_DVD_PLAYER			7
#define OUTPUT_FORMAT_I_AUTHOR					8
#define OUTPUT_FORMAT_EBU_STL					9
#define OUTPUT_FORMAT_SRT						10

/* line length warning in next_too_long */
#define WARN_NUMBER_LINES	3

/* for animation templates status, use 1, 2, 4 */
#define ANIMATION_TEMPLATE_CENTER			1
#define ANIMATION_TEMPLATE_REFORMAT			2
#define ANIMATION_TEMPLATE_SHOW_X_Y_DELTA	4
#define ANIMATION_TEMPLATE_DISPLAY			8

int debug_flag;
char *home_dir;
char *user_name;
int new_york_offset;
int frame_form_show_marked_only_flag;
int main_form_modified_flag;
int selected_start_frame;
int selected_end_frame;
char *selected_text;
unsigned long selected_start_sample;
unsigned long selected_end_sample;
int text_duration_multiplier;
int main_form_fontsize;
int project_form_fontsize;
int export_form_fontsize;
int fonts_form_fontsize;
int special_characters_form_fontsize;
int ebu_general_subtitle_information_form_fontsize;
int text_properties_form_fontsize;
int global_subtitle_palette_form_fontsize;
int tab_size;
char *selected_project;
int main_form_file_menu_selection;
int project_form_shown_flag;
int export_form_shown_flag;
int fonts_form_shown_flag;
int subtitle_font_form_shown_flag;
int special_character_form_shown_flag;
int ebu_general_subtitle_information_form_shown_flag;
int text_properties_form_shown_flag;
int global_subtitle_palette_form_shown_flag;
int subtitle_color_selector_form_shown_flag;
int animation_template_form_shown_flag;
char *selected_device;
char *selected_data_directory;
int spellcheck_input_flag;
int selected_volume;
char *editor_command;
char *spellcheck_command;
char base_dir[20];
unsigned long selected_picture;
int color_depth;
int color_depth_mode;
int show_video_flag;
int clicked_picture;
struct timeval *start_timeval;
struct timeval *current_timeval;
int current_frame;
int frame_memory_1;
int video_error;
int select_frame_list_entry_flag;
int current_frame_input_value;
int frame_input_value;
int frame_list_browser_clicked_frame;
int drop_shadow;

int org_start_frame, org_end_frame, new_start_frame, new_end_frame;
double dnew_old_frame_ratio;
int frame_shift;

int audio_mode;
int audio_sample_speed;
int allow_idle_cb;

double dframes_per_second;
double dmilli_seconds_per_frame;

int frame_mode;
char *data_file_name;

int h_size;
int v_size; 
double h_factor;
double v_factor;
int h_margin;
int v_margin;
int screen_start[MAX_H_PIXELS];
char screen_text[MAX_SCREEN_LINES][MAX_H_PIXELS];
int vert_position;
int line_height;
int line_h_start, line_h_end;
int wtop, wbottom, hstart, hend;
int window_top, window_bottom;
int screen_lines;
uint8_t image_buffer[2048 * 1024 * 4];
int let_microdvdplayer_format_flag;

/* for xforms fonts */
int selected_articles_font;
int selected_global_font;
int fonts_mode;
int max_fonts;
int used_font;
char* used_charset;

/* for subtitle fonts */
char *default_subtitle_font_name;
int default_subtitle_font_symbols;
int default_subtitle_font_size;
int default_subtitle_iso_extention;
double default_subtitle_blur_radius;
double default_subtitle_outline_thickness;

int default_subtitle_anti_alias_flag;
int default_subtitle_no_kerning_flag;

int default_subtitle_background_contrast;
int default_subtitle_body_contrast;
int default_subtitle_outline1_contrast;
int default_subtitle_outline2_contrast;

int default_subtitle_background_color;
int default_subtitle_body_color;
int default_subtitle_outline1_color;
int default_subtitle_outline2_color;

int default_subtitle_center_flag;
int default_subtitle_extra_character_space;
int default_subtitle_extra_character_vspace;


int preview_flag;
int new_preview_flag;
int draw_mode;
int output_format;

/* for DVD */
int hold_text_properties_flag;
int xste_rgb_palette[16][3]; // r g b 

int text_in_anti_alias_flag;
int text_in_no_kerning_flag;

int text_in_background;
int text_in_body;
int text_in_outline1;
int text_in_outline2;

int text_in_background_contrast;
int text_in_body_contrast;
int text_in_outline1_contrast;
int text_in_outline2_contrast;

double text_in_blur_radius;
double text_in_outline_thickness;
int text_in_extra_character_space;
int text_in_extra_character_vspace;

int text_in_symbols;
int text_in_fontsize;
int text_in_iso_extension;
char *text_in_fontname;

int text_in_center_flag;

/* for ebu stl output */
struct ebu_gsi *pebu_gsi;                                                                       

int ppml_use_dvd_colors_flag;
int ppml_enable_monitor_flag;
int no_kerning_flag;

char *video_filename;
mpeg3_t* video_file;
int video_file_video_streams;
int video_file_height, video_file_width;
long video_file_frames;
float video_file_fps;
int video_file_color_model;
int video_file_init_flag;
int video_in_preview_flag;
int play_right_mouse_flag;
int play_button;

int size_error_flag;
int video_have_warning_flag;

int show_time_overlap_flag;
int synthesize_flag;
int enable_chapter_list_output_flag;
char *subtitle_font;

struct animation_template *selected_animation_template; 
int use_animation_templates_flag;
int selected_animation_template_browser_line;
int play_start_flag;

#define DATA_FILE_NAME	"rframes.dat"

#define DATA_DIRECTORY	".subtitles"
#define AUDIO_DEVICE	"/dev/dsp"
#define AUDIO_MIXER_DEVICE "/dev/mixer"	
#define RAW_SAMPLE_SPEED	11025

/* for audio_mode */
#define AUDIO_RAW	0
#define AUDIO_WAV	1
#define AUDIO_MP3	2

/* defaults */
#define DEFAULT_EDIT_COMMAND		"rxvt -geometry 100x28  -sl 500 -e joe"
#define DEFAULT_SPELL_CHECK_COMMAND	"rxvt -geometry 80x28  -sl 500 -fn 10x20 -e ispell -d nederlands"
#define DEFAULT_SUBTITLE_FONT "arial.ttf"

/* for system used */
#define PAL_FRAMES_PER_SECOND	25.0
#define NTSC_FRAMES_PER_SECOND	29.97

/* this last so proto knows about structure definitions etc. */
#include "xste_proto.h"

/* comment this out if xforms crashes in error message popups (error messages will still go to stderr) */
//#define ALLOW_ERROR_MESSAGES_IN_IDLE_CB

/* define this 0 if libmpeg3 corrupts data in video display */
#define USE_MMX_IN_LIBMPEG3 	1

/* set to the number of processors used */
#define CPUS_USED_BY_LIBMPEG3	1

//#define LIBMPEG3_VERSION_1_5_3 
#define LIBMPEG3_VERSION_1_7

#define VERSION "xste-3.6"

#endif /* FD_xste_h_ */

