/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _XSTE_PROTO_H_
#define _XSTE_PROTO_H_

#include <jpeglib.h>
#include <setjmp.h>


extern int save_animation_templates();
extern int add_animation_template(char *name);
extern int show_animation_templates(int position); 
extern int delete_animation_template(char *name);
extern int readline_msdos(FILE *file, char *contents);
extern int test_for_same_colors();
extern int write_formatted_entry_microdvdplayer_format(struct frame *pa, FILE *fptr);
extern int save_selected_fonts();
extern int swap_font_position(struct font *ptop, struct font *pbottom);
extern int get_max_fonts(int *fonts);
extern int sort_fonts();
extern int set_font_radio_buttons(int mode);
extern int snap_to_frame(int *frame);
extern int show_text_properties_form();
extern int delete_all_empty_lines();
extern int edit_frame_list();
extern int write_ifo_color_table();
extern int write_microdvdplayer_list();
extern int write_chapter_list();
extern int load_suti_file(char *pathfilename);
extern int load_ssa_file(char *pathfilename);
extern int load_srt_file(char *pathfilename);
extern int show_export_form();
extern int show_fonts_form();
extern int show_global_subtitle_palette_form();
extern int show_special_characters_form();
extern int load_selected_fonts();
extern int add_system_fonts();
extern int load_animation_templates();
extern int play_audio_wav(unsigned long start_sample, unsigned long end_sample);
extern int set_force_duration_button(int frame);
extern int set_article_fonts(int font);
extern int set_global_fonts(int font);
extern int set_current_frame_input(int framenr);
extern int set_frame_input(int framenr);
extern int add_project(char *name);
extern int show_ebu_general_subtitle_information_form();
extern int add_objects(uint8_t *buffer, int frame);
extern int get_x11_bpp();
extern void putimage(int xsize, int ysize);
extern int openwin(int argc, char *argv[], int xsize, int ysize);
extern unsigned char *getbuf(void);
extern void closewin(void);
extern int wingetdepth(void);
extern int resize_window(int xsize, int ysize);
extern int preview_display();
extern int set_end_frame(int frame_nr, int end_frame);
extern int read_in_ssa_file(FILE *finptr);
extern int sort_animation_templates_for_pzpos();
extern struct frame *lookup_this_or_earlier_frame_that_is_no_animation_template_reference(int frame);
extern int create_subtitle_animation_template();
extern void animation_template_form_xpos_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_ypos_slider_cb(FL_OBJECT *ob, long data);
extern int add_text_yuv(uint8_t *buffer, int xpos, int ypos,\
	double color, double saturation, double contrast, double transparency,\
	int espace, char *text, font_desc_t *pfd);
extern int print_char_col(\
	int x, int y, int c,\
	double color, double contrast, double transparency, double saturation, font_desc_t *pfd);
extern void draw_alpha_rgb24_r(\
	int x0, int y0,\
	int w, int h,\
	uint8_t *src, uint8_t *srca, int stride,\
	int r, int g, int b, double contrast, double transparency);
extern int select_heading_or_x_y(int x_y);
extern void animation_template_form_heading_or_x_y_select_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dxpos_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dxpos_slider_reset_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dypos_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dypos_slider_reset_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_despace_slider_reset_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_espace_slider_reset_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dcontrast_slider_reset_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dtransparency_slider_reset_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dcolor_slider_reset_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dsaturation_slider_reset_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dheading_slider_reset_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dspeed_slider_reset_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dzpos_slider_reset_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_zpos_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dzpos_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_heading_dial(FL_OBJECT *ob, long data);
extern void animation_template_form_dheading_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_speed_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dspeed_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_x_y_positioner_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_espace_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_despace_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_contrast_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dcontrast_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_transparency_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dtransparency_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_color_degrees_output_field_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dcolor_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_saturation_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dsaturation_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_x_y_positioner_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_heading_dial_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_speed_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dspeed_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_x_y_positioner_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_heading_dial_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_speed_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_dspeed_slider_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_saturation_slider_cb(FL_OBJECT *ob, long data);
extern int set_template_dial_color(double degrees, double saturation);
extern struct animation_template *lookup_animation_template(char *name);
extern int add_animation_object_to_ppml_file(int frame, char *name, FILE *fptr, char *text);
extern int write_ppml_list_using_animation_templates_for_subtitler_yuv();
extern int clear_animation_template_form();
extern int fill_in_animation_template_form(struct animation_template *pa);
extern struct animation_template *animation_template_line_to_form(int line);
extern void export_form_use_animation_templates_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_center_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_reformat_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_color_circle_dial_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_fontname_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_fontname_output_field_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_fontname_output_field_text_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_default_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_character_point_size_input_field_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_character_style_input_field_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_outline_thickness_input_field_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_blur_radius_input_field_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_vespace_input_field_cb(FL_OBJECT *ob, long data);
extern int swap_animation_template_position(\
	struct animation_template *ptop, struct animation_template *pbottom);
extern char *line_to_animation_template(int line);
extern int animation_template_to_line(char *name, int *line);
extern void animation_template_form_browser_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_browser_double_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_input_field_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_delete_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_add_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_animation_templatesize_up_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_animation_templatesize_down_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_animation_templatesize_up_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_animation_templatesize_down_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_cancel_button_cb(FL_OBJECT *ob, long data);
extern void animation_template_form_accept_button_cb(FL_OBJECT *ob, long data);
extern int show_animation_template_form();

extern font_desc_t *make_old_font(\
	char *font_name, int font_size, int iso_extention, double outline, double blur);
extern int write_ppml_for_subtitler_yuv_list();
extern void export_form_enable_ppml_for_subtitler_yuv_output_button_cb(FL_OBJECT *ob, long data); 
extern struct frame *lookup_this_or_earlier_frame(int frame);
extern int write_srt_list();
extern int read_in_srt_file();
extern void export_form_enable_srt_output_button_cb(FL_OBJECT *ob, long data);
extern void export_form_enable_chapter_list_output_button_cb(FL_OBJECT *ob, long data);
extern int clean_text(char *text, char *cleaned_text);
extern int extract_command(char *text, char *text_part, char *command_part);
extern int speak_text(char *text);
extern int combine_synthesized_wave_files();
extern int write_synthesized_wave_files();
extern int text_to_wave(int frame, char *text);
extern void main_form_show_time_overlap_button_cb(FL_OBJECT *ob, long data);
extern int find_next_too_long_line();
extern int calculate_text_lines(struct frame *pa, int *lines);
extern int take_preview_snapshot(int frame);
extern int test_bitmap(\
	char *file_name, int xpos, int ypos, int xsize, int ysize,\
	int bg, int fg, int emph1, int emph2,\
	int bgcol, int fgcol, int emph1col, int emph2col);
extern int set_volume(int volume);
extern int idle_cb(XEvent *ev, void *data);
extern void main_form_preview_snapshot_button_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_espace_input_field_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_vespace_input_field_cb(FL_OBJECT *ob, long data);
extern void subtitle_font_form_espace_input_field_cb(FL_OBJECT *ob, long data);
extern void subtitle_font_form_vespace_input_field_cb(FL_OBJECT *ob, long data);
extern int force_default_font_parameters_to_all_frames();
extern void subtitle_font_form_no_kerning_button_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_no_kerning_button_cb(FL_OBJECT *ob, long data);
extern void subtitle_font_form_anti_alias_button_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_anti_alias_button_cb(FL_OBJECT *ob, long data);
extern int get_current_date(char *date);
extern int load_nandub_file(char *pathfilename);
extern void export_form_ppml_use_dvd_colors_button_cb(FL_OBJECT *ob, long data);
extern void export_form_ppml_enable_monitor_button_cb(FL_OBJECT *ob, long data);
extern int test_for_same_default_colors();
extern int set_default_subtitle_properties();
extern void set_subtitle_font_form_center_text_button_label(int state);
extern void subtitle_font_form_center_text_button_cb(FL_OBJECT *ob, long data);
extern void set_center_text_button(int state);
extern void text_properties_form_center_text_button_cb(FL_OBJECT *ob, long data);
extern font_desc_t *add_font(\
    char *name, int font_symbols, int size, int iso_extension, double outline_thickness, double blur_radius,\
	int espace, int vespace);
extern struct subtitle_fontname *lookup_subtitle_fontname(char *name);
extern struct subtitle_fontname *install_subtitle_fontname_at_end_of_list(char *name);
extern int delete_subtitle_fontname(int subtitle_fontnamenr);
extern int delete_all_subtitle_fontnames();
extern int set_global_subtitle_palette_defaults();
extern int set_text_properties_defaults();
extern int prepare_charset();
extern int frame_font_parameters_to_vars(int frame);
extern int set_subtitle_properties(\
    int selected_start_frame,\
	int alias_flag,\
	int no_kerning_flag,\
    int background,\
    int body,\
    int outline1,\
    int outline2,\
    int background_contrast,\
    int body_contrast,\
    int outline1_contrast,\
    int outline2_contrast,\
    double blur_radius,\
    double outline_thickness,\
	int symbols,\
    int fontsize,\
    int iso_extension,\
    char *fontname,\
	int center_flag,\
	int espace, \
	int vespace);
extern void text_properties_form_fontname_button_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_fontsize_input_field_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_iso_extension_number_input_field_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_dvd_default_button_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_outline_thickness_input_field_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_blur_radius_input_field_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_color0_button_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_color1_button_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_color2_button_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_color3_button_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_contrast0_input_field_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_contrast1_input_field_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_contrast2_input_field_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_contrast3_input_field_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_fontsize_up_button_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_fontsize_down_button_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_cancel_button_cb(FL_OBJECT *ob, long data);
extern void text_properties_form_accept_button_cb(FL_OBJECT *ob, long data);
//static int atclose(FL_FORM * form, void *ev);
extern int subtitle_color_selector_form_set_all_color_buttons();
extern int subtitle_color_selector_form_set_color_button(int button);
extern int show_subtitle_color_selector_form(int color);
extern int set_color_circle(int red, int green, int blue);
extern void global_subtitle_palette_form_color_circle_input_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color_circle_dial_cb(FL_OBJECT *ob, long data);
extern int set_color_sliders(int selected);
extern int global_subtitle_palette_form_set_all_color_buttons();
extern int global_subtitle_palette_form_set_color_button(int button);
extern void global_subtitle_palette_form_defaults_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color_slider_red_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color_slider_green_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color_slider_blue_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color0_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color1_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color2_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color3_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color4_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color5_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color6_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color7_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color8_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color9_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color10_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color11_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color12_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color13_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color14_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_color15_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_fontsize_up_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_fontsize_down_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_cancel_button_cb(FL_OBJECT *ob, long data);
extern void global_subtitle_palette_form_accept_button_cb(FL_OBJECT *ob, long data);
extern void main_form_global_subtitle_palette_button_cb(FL_OBJECT *ob, long data);
extern void main_form_hold_text_properties_button_cb(FL_OBJECT *ob, long data);
extern int set_ebu_gsi_form_vars_to_fields();
extern struct ebu_tti *lookup_ebu_tti(char *name);
extern struct ebu_tti *install_ebu_tti_at_end_of_list(char *name);
extern int delete_ebu_tti(int ebu_ttinr);
extern int delete_all_ebu_ttis();
extern int xste_frames_to_ebu_gsi_tti();
extern int set_timecode_valid_button();
extern int save_ebu_gsi();
extern int load_ebu_gsi();
extern int set_ebu_sti_defaults(char *language);
extern void export_form_ebu_general_subtitle_information_button_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_code_page_number_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_disk_format_code_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_standard_code_open_button_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_standard_code_teletext1_button_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_standard_code_teletext2_button_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_character_code_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_language_code_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_original_program_title_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_original_episode_title_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_translated_program_title_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_translated_episode_title_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_translators_name_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_translators_contact_details_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_subtitle_list_reference_code_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_creation_date_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_revision_date_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_revision_number_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_tti_blocks_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_number_of_subtitles_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_subtitle_groups_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_max_columns_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_max_rows_title_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_timecode_valid_button_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_timecode_start_of_program_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_timecode_first_cue_in_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_number_of_disks_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_disk_sequence_number_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_country_of_origin_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_publisher_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_editors_name_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_editors_contact_details_input_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_defaults_dutch_button_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_cancel_button_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_accept_button_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_fontsize_down_button_cb(FL_OBJECT *ob, long data);
extern void ebu_general_subtitle_information_form_fontsize_up_button_cb(FL_OBJECT *ob, long data);
extern int format_and_center_text_in_arays(struct frame *pa);
extern void subtitle_font_form_contrast0_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void subtitle_font_form_contrast1_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void subtitle_font_form_contrast2_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void subtitle_font_form_contrast3_input_field_cb(\
	FL_OBJECT *ob, long data);
extern int show_subtitle_font_form();
extern void subtitle_font_form_fontname_button_cb(FL_OBJECT *ob, long data);
extern void subtitle_font_form_outline_thickness_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void subtitle_font_form_outline_blur_radius_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void subtitle_font_form_dvd_default_button_cb(FL_OBJECT *ob, long data);
extern void subtitle_font_form_cvd_default_button_cb(FL_OBJECT *ob, long data);
extern void subtitle_font_form_svcd_default_button_cb(FL_OBJECT *ob, long data);
extern void subtitle_font_form_color_body_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void subtitle_font_form_color_outline_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void subtitle_font_form_color_background_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void subtitle_font_form_color0_button_cb(FL_OBJECT *ob, long data);
extern void subtitle_font_form_color1_button_cb(FL_OBJECT *ob, long data);
extern void subtitle_font_form_color2_button_cb(FL_OBJECT *ob, long data);
extern void subtitle_font_form_color3_button_cb(FL_OBJECT *ob, long data);
extern void subtitle_font_form_subtitle_fontsize_up_button_cb(\
	FL_OBJECT *ob, long data);
extern void subtitle_font_form_subtitle_fontsize_down_button_cb(\
	FL_OBJECT *ob, long data);
extern void subtitle_font_form_cancel_button_cb(FL_OBJECT *ob, long data);
extern void subtitle_font_form_accept_button_cb(FL_OBJECT *ob, long data);

extern char *get_universal_time_as_string();
extern int write_iauthor_list();
extern void export_form_enable_iauthor_output_button_cb(\
	FL_OBJECT *ob, long data);
extern int set_vars_values();
extern int preview(char *text);
extern void main_form_preview_button_cb(FL_OBJECT *ob, long data);
extern void main_form_video_in_preview_button_cb(FL_OBJECT *ob, long data);
extern int alpha(double outline_thickness, double blur_radius);
extern font_desc_t *make_font(\
	char *font_name, int font_symbols, int font_size, int iso_extention,\
	double outline_thickness, double blur_radius);
extern int set_mplayer_font(int fontsize);
extern void export_form_let_microdvdplayer_format_button_cb(\
	FL_OBJECT *ob, long data);
extern void export_form_enable_microdvdplayer_output_button_cb(\
	FL_OBJECT *ob, long data);
extern int get_h_pixels(int c, struct frame *pa);
extern char *p_reformat_text(struct frame *pa, int max_pixels);
extern int p_center_text(char *text, struct frame *pa);
extern int add_text(\
	int x, int y, char *text, struct frame *pa, int u, int v,\
	double contrast, double transparency);
extern int add_text_x(\
	int x, int y, char *text, struct frame *pa, int u, int v,\
	double contrast, double transparency);
extern int print_char(\
	int x, int y, int c, struct frame *pa, int u, int v,\
	double contrast, double transparency, font_desc_t *pfd, int is_space);
extern int print_char_x(\
	int x, int y, int c, struct frame *pa, int u, int v,\
	double contrast, double transparency, font_desc_t *pfd, int is_space);
extern void draw_alpha(\
	int x0 ,int y0,\
	struct frame *pa,\
	int w, int h,\
	uint8_t *src, uint8_t *srca, int stride, int u, int v,\
	double contrast, double transparency, int is_space);
extern void draw_alpha_x(\
	int x0 ,int y0,\
	struct frame *pa,\
	int w, int h,\
	uint8_t *src, uint8_t *srca, int stride, int u, int v,\
	double contrast, double transparency, int is_space);
extern void draw_alpha_rgb24(\
	int w, int h,\
	struct frame *pa,\
	unsigned char* src, unsigned char *srca, int srcstride,\
	unsigned char* dstbase, int dststride, int is_space);
extern void draw_alpha_rgb24_x(\
	int w, int h,\
	struct frame *pa,\
	unsigned char* src, unsigned char *srca, int srcstride,\
	unsigned char* dstbase, int dststride, int is_space);
extern int create_bitmap_file(struct frame *pa);
extern int write_submux_list();
extern int write_submux_dvd_list();
extern int write_ebu_stl_list();
extern void export_form_enable_submux_output_button_cb(FL_OBJECT *ob, long data);
extern void export_form_enable_submux_dvd_output_button_cb(FL_OBJECT *ob, long data);
extern void export_form_enable_ebu_stl_output_button_cb(FL_OBJECT *ob, long data);
extern void export_form_enable_ebu_stl_output_button_cb(FL_OBJECT *ob, long data);
extern int test_length(char *text, int *mode);
extern int calculate_and_set_h_factor();
extern int calculate_and_set_h_margin();
extern int calculate_and_set_v_factor();
extern int calculate_and_set_v_margin();
extern void main_form_h_margin_input_field_cb(FL_OBJECT *ob, long data);
extern void main_form_v_margin_input_field_cb(FL_OBJECT *ob, long data);
extern void export_form_ppml_header_path_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void export_form_include_ppml_header_output_button_cb(\
	FL_OBJECT *ob, long data);
extern void subtitle_font_form_character_style_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void main_form_h_size_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void main_form_h_factor_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void main_form_v_size_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void main_form_v_factor_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void subtitle_font_form_character_point_size_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void posting_special_character_button_cb(FL_OBJECT *ob, long data);
extern void special_characters_form_input_cb(FL_OBJECT *ob, long data);
extern void special_characters_form_fontsize_up_button_cb(\
	FL_OBJECT *ob, long data);
extern void special_characters_form_fontsize_down_button_cb(\
	FL_OBJECT *ob, long data);
extern void special_characters_form_cancel_button_cb(\
	FL_OBJECT *ob, long data);
extern void fonts_form_article_fonts_button_cb(FL_OBJECT *ob, long data);
extern char *line_to_iso(int line, int *iso_extention);
extern void fonts_form_global_fonts_button_cb(FL_OBJECT *ob, long data);
extern void fonts_form_default_fonts_button_cb(FL_OBJECT *ob, long data);
extern struct font *lookup_font(char *name);
extern struct font *install_font_at_end_of_list(char *name);
extern int delete_font(long font_id);
extern int delete_all_fonts();
extern void add_xforms_font(const char *name);
extern int add_X_font(const char *name, char*iso_name, int iso_number);
extern void addit(const char *str);
extern char *line_to_font(int line);
extern int show_fonts();
extern void fonts_form_browser_cb(FL_OBJECT *ob, long data);
extern void fonts_form_browser_double_cb(FL_OBJECT *ob, long data);
extern void fonts_form_fontsize_up_button_cb(\
	FL_OBJECT *ob, long data);
extern void fonts_form_fontsize_down_button_cb(\
	FL_OBJECT *ob, long data);
extern void fonts_form_accept_button_cb(FL_OBJECT *ob, long data);


extern int move_from_frame_list(int old_frame, int new_frame);
extern void main_form_move_from_switch_cb(FL_OBJECT *ob, long data);
extern int load_ppml_file(char *pathfilename);
extern int readline_ppml(FILE *file, char *contents);
extern void set_frames_per_second_input_field_color();
extern struct temp_frame *lookup_temp_frame(char *name);
extern struct temp_frame *install_temp_frame_at_end_of_list(char *name);
extern int delete_temp_frame(int temp_framenr);
extern int delete_all_temp_frames();
extern int recalculate_frame_list();
extern void main_form_align_start_button_cb(FL_OBJECT *ob, long data);
extern void main_form_align_end_button_cb(FL_OBJECT *ob, long data);
extern void export_form_enable_suti_output_button_cb(\
	FL_OBJECT *ob, long data);
extern void export_form_enable_ppml_output_button_cb(\
	FL_OBJECT *ob, long data);
extern void export_form_enable_ssa_output_button_cb(\
	FL_OBJECT *ob, long data);
extern void export_form_enable_vplayer_output_button_cb(\
	FL_OBJECT *ob, long data);
extern void export_form_cancel_button_cb(FL_OBJECT *ob, long data);
extern void export_form_accept_button_cb(FL_OBJECT *ob, long data);
extern void export_form_fontsize_down_button_cb(FL_OBJECT *ob, long data);
extern void export_form_fontsize_up_button_cb(FL_OBJECT *ob, long data);

extern int set_audio_mark();
extern int set_text_hold_flag(int frame, int hold_flag);
extern int get_text_hold_flag(int frame, int *hold_flag);
extern int set_memory_button_labels();
extern int select_frame_list_entry();
extern int save_project_vars();
extern int load_project_vars();
extern void *video_routine();
extern int video_init();
extern int video_display();
extern void main_form_video_display_button_cb(\
	FL_OBJECT *ob, long data);
extern void main_form_next_red_button_cb(FL_OBJECT *ob, long data);
extern void main_form_volume_slider_cb(FL_OBJECT *ob, long data);
extern void main_form_edit_frame_list_button_cb(\
	FL_OBJECT *ob, long data);
extern void main_form_erase_all_empty_lines_button_cb(\
	FL_OBJECT *ob, long data);
extern int spelcheck_all();
extern int spellcheck_input_field();
extern void main_form_spellcheck_input_button_cb(\
	FL_OBJECT *ob, long data);
extern void main_form_file_menu_cb(FL_OBJECT *ob, long data);
extern struct project *lookup_project(char *name);
extern struct project *install_project_at_end_of_list(char *name);
extern int delete_project(char *name);
extern int delete_all_projects();
extern int sort_projects();
extern int load_projects();
extern int save_projects();
extern int delete_a_project(char *name);
extern int show_project_form();
extern int save_project_setting(char *name);
extern int load_project_setting(char *name);
extern int select_project(char *name);
extern int show_projects(int position);
extern char *line_to_project(int line);
extern int project_to_line(char *name, int *line);
extern int set_title();
extern int swap_position(struct project *ptop, struct project *pbottom);
extern void project_form_input_field_cb(FL_OBJECT *ob, long data);
extern void project_form_browser_cb(FL_OBJECT *ob, long data);
extern void project_form_browser_double_cb(FL_OBJECT *ob, long data);
extern void project_form_delete_button_cb(FL_OBJECT *ob, long data);
extern void project_form_add_button_cb(FL_OBJECT *ob, long data);
extern void project_form_fontsize_up_button_cb(FL_OBJECT *ob, long data);
extern void project_form_fontsize_down_button_cb(FL_OBJECT *ob, long data);
extern void project_form_cancel_button_cb(FL_OBJECT *ob, long data);
extern void project_form_accept_button_cb(FL_OBJECT *ob, long data);
extern int main_form_reset_last_found_line();
extern int save_setting(char *type, char *string);
extern char *load_setting(char *type);
extern int save_fontsizes();
extern int load_fontsizes();
extern int save_general_settings();
extern int load_general_settings();
extern int set_tabs(int tabsize);
extern char *expand_tabs(char *text, int tabsize);
extern void main_form_text_hold_button_cb(\
	FL_OBJECT *ob, long data);
extern void main_form_text_duration_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void main_form_frames_per_second_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void main_form_set_PAL_fps_button_cb( FL_OBJECT *ob, long data);
extern void main_form_set_NTSC_fps_button_cb( FL_OBJECT *ob, long data);

extern int recalculate_end_frames();
extern int play_audio_raw(unsigned long start_sample, unsigned long end_sample);
extern int play_audio_mp3(int start_frame);
extern int text_to_frames(char *text, int *frames);
extern void main_form_synthesize_switch_cb(FL_OBJECT *ob, long data);
extern void main_form_output_switch_cb(FL_OBJECT *ob, long data);
extern void main_form_auto_switch_cb(FL_OBJECT *ob, long data);
extern int find_start_points_in_raw_file(\
	char *filename, char *device, int window, int length);
extern int find_start_points_in_wave_file(\
	char *filename, char *device, int window, int length);
extern struct frame *install_frame_in_position(char *name, int *new_flag);
extern struct frame *add_frame_in_position(\
	char *text, int start_framenr, int end_framenr, int force_duration, int *new_frame_flag);
extern char *strsave(char *s);
extern int readline(FILE *file, char *contents);
extern int integer_to_fontsize(int fontsize);
extern int ogettime(
	char *weekday,
	char *month,
	int *monthday,
	int *hour,
	int *minute,
	int *second,
	int *year
	);
//extern int header_check(wave_header *head);
extern int rec_init(int mode);
extern int recplay (char *filename, int mode);
extern int play_file(\
	char *filename, char * device,\
	unsigned long start_sample, unsigned long end_sample, int speed);
extern void *record_routine();
extern void *play_routine();
extern int recorder_init();
extern int recorder(int command);
extern struct iframe *lookup_iframe(char *name);
extern struct iframe *install_iframe_at_end_of_list(char *name);
extern int delete_iframe(char *name);
extern int delete_all_iframes();
extern int get_sample(int framenr, unsigned long *sample);
extern int get_next_frame_and_sample(unsigned long sample,\
	int *next_frame, unsigned long *next_sample);
extern struct frame *lookup_frame(char *name);
extern struct frame *install_frame_at_end_of_list(char *name);
extern int delete_frame(int framenr);
extern int delete_all_frames();
extern int load_frames();
extern int save_frames();
extern int show_frame_form();
extern int show_frames(int position);
extern int line_to_frame(int line, int *start_frame, int *end_frame);
extern int line_to_next_frame(int line, int *start_frame, int *end_frame);
extern int frame_to_line(int framenr, int *line);
extern int frame_to_next_line(int framenr, int *line);
extern int add_frame(\
	char *text, int start_framenr, int end_framenr, int force_duration);
extern void replace(char *text, char *string, char *replace, char *result);
extern int set_text_input(int start_frame);
extern int search_and_select_next_frame();
extern int set_frame_status(char *frame, int status);
extern int get_frame_status(char *frame, int *status);
extern int search_in_for(char *database, char *data, int case_sensitive);
extern char *strstr_case_insensitive(char *s, char *t);
extern void main_form_play_part_cb(FL_OBJECT *ob, long data);
extern void main_form_mem1_button_cb(FL_OBJECT *ob, long data);
extern void main_form_rcl_button_cb(FL_OBJECT *ob, long data);
extern void main_form_snap_button_cb(FL_OBJECT *ob, long data);
extern void main_form_browser_cb(FL_OBJECT *ob, long data);
extern void main_form_browser_double_cb(FL_OBJECT *ob, long data);
extern void main_form_audio_mode_button_cb(FL_OBJECT *ob, long data);
extern void main_form_search_input_field_cb(FL_OBJECT *ob, long data);
extern void main_form_search_case_button_cb(FL_OBJECT *ob, long data);
extern void main_form_search_button_cb(FL_OBJECT *ob, long data);
extern void main_form_clear_button_cb(FL_OBJECT *ob, long data);
extern void main_form_add_button_cb(FL_OBJECT *ob, long data);
extern void main_form_text_input_field_cb(FL_OBJECT *ob, long data);
extern void main_form_frame_input_field_cb(FL_OBJECT *ob, long data);
extern void main_form_frame_now_button_cb(FL_OBJECT *ob, long data);;
extern void main_form_current_frame_input_field_cb(\
	FL_OBJECT *ob, long data);
extern void main_form_fontsize_down_button_cb(FL_OBJECT *ob, long data);
extern void main_form_fontsize_up_button_cb(FL_OBJECT *ob, long data);
extern void main_form_delete_button_cb(FL_OBJECT *ob, long data);
extern void main_form_exit_switch_cb(FL_OBJECT *ob, long data);
extern void main_form_record_switch_cb(FL_OBJECT *ob, long data);
extern void main_form_play_button_cb(FL_OBJECT *ob, long data);
extern int sort_frames();
extern int swap_frame_position(struct frame *ptop, struct frame *pbottom);

extern int ogettime(
	char *weekday,
	char *month,
	int *monthday,
	int *hour,
	int *minute,
	int *second,
	int *year
	);
extern void option_evaluation_form_filter_input_field_cb(\
	FL_OBJECT *ob, long data);
extern int read_settings();
extern int write_settings();

extern char *strsave(char *s);

extern int write_vplayer_list();
extern int write_ssa_list();
extern int write_ppml_list();
extern int write_suti_list();

#endif /* _XSTE_PROTO_H_ */
